/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PreLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 191;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 142;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 141;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 196;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 88;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 190;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 87;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 194;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 195;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 93;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 210;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 185;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 129;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 204;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 143;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 187;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 173;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 130;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 125;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 171;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 172;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 159;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 68;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 122;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 203;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 123;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 170;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 169;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 202;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 205;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 84;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 157;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 168;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 90;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 105;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 53;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 104;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 158;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 67;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 150;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 61;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 140;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 82;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 127;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 57;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 60;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 59;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 58;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 62;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 54;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 186;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 119;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 70;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 89;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 108;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 166;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 151;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 80;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 147;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 121;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 148;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 71;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 126;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 85;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 144;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 133;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 132;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 145;	 // "expand_const_fpowi"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_global_offset", 16) != 0)
          break;
        return 214;	 // "fold_global_offset"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 98;	 // "fptrunc_fpext_fold"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
            break;
          return 55;	 // "select_of_truncate"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
            break;
          return 116;	 // "sext_inreg_of_load"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "uffle_to_extract", 16) != 0)
          break;
        return 215;	 // "shuffle_to_extract"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 16 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 86;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 139;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 164;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 135;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 134;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xt", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "uaddv_to_uaddlv", 15) != 0)
          break;
        return 217;	 // "ext_uaddv_to_uaddlv"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "nd_through_phis", 15) != 0)
          break;
        return 101;	 // "extend_through_phis"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 63;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 209;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 107;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 106;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 83;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 120;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 102;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 192;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 75;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 175;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 97;	 // "bitcast_bitcast_fold"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_redundant_trunc", 19) != 0)
        break;
      return 213;	 // "icmp_redundant_trunc"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 208;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 117;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 124;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 76;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 207;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 193;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 167;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 136;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xt_addv_to_udot_addv", 20) != 0)
        break;
      return 216;	 // "ext_addv_to_udot_addv"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "constant_to_constant", 20) != 0)
        break;
      return 212;	 // "fconstant_to_constant"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'p':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ush_", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "dd_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 221;	 // "push_add_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 219;	 // "push_add_through_zext"
        }
        break;
      case 's':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "ub_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 220;	 // "push_sub_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 218;	 // "push_sub_through_zext"
        }
        break;
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 92;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 72;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 206;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 197;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 165;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 184;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 155;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 156;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 153;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 111;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 211;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 77;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 174;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 91;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 115;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 95;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 56;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 154;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 137;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 138;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 78;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 73;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 118;	 // "narrow_binop_feeding_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_to_zext_inreg", 23) != 0)
        break;
      return 128;	 // "sext_inreg_to_zext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 146;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 161;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 162;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 94;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 198;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 65;	 // "extract_vec_elt_build_vec"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 100;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 74;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 189;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 152;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 99;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 200;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 188;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 113;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 114;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 96;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 201;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 112;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 131;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 79;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 149;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 163;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 69;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 199;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 110;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 160;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 176;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 180;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 66;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 178;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 64;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 81;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 181;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 103;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 177;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 182;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 183;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 222}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PreLegalizerCombinerOption;
static cl::list<std::string> AArch64PreLegalizerCombinerDisableOption(
    "aarch64prelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PreLegalizerCombinerOnlyEnableOption(
    "aarch64prelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 1;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasDotProdBit = 0,
};

PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  return Features;
}

void AArch64PreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
};
bool AArch64PreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
};

bool AArch64PreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PreLegalizerCombinerImpl::CustomRendererFn
AArch64PreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
};
bool AArch64PreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    // Match Patterns
    if(![&](){return matchFConstantToConstant(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFConstantToConstant(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchICmpRedundantTrunc(*State.MIs[0], MRI, Helper.getValueTracking(), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyICmpRedundantTrunc(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    std::pair<uint64_t, uint64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFoldGlobalOffset(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldGlobalOffset(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    // Match Patterns
    if(![&](){return Helper.matchShuffleToExtract(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShuffleToExtract(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    std::tuple<Register, Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtAddvToUdotAddv(*State.MIs[0], MRI, STI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtAddvToUdotAddv(*State.MIs[0], MRI, B, Observer, STI, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    std::pair<Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtUaddvToUaddlv(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtUaddvToUaddlv(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    // Match Patterns
    if(![&](){return matchPushAddSubExt(*State.MIs[0], MRI, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());}()) {
      return false;
    }
    // Apply Patterns
    applyPushAddSubExt(*State.MIs[0], MRI, B, State.MIs[1]->getOpcode() == TargetOpcode::G_SEXT, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(296), /*)*//*default:*//*Label 98*/ GIMT_Encode4(7271),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(1114), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(1126),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1741),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(2074),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2240),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2313),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2397),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2442), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2509),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2790),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(3035), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(3136), GIMT_Encode4(0),
     /*  210 */ /*TargetOpcode::G_GLOBAL_VALUE*//*Label 12*/ GIMT_Encode4(3148), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 13*/ GIMT_Encode4(3160), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 14*/ GIMT_Encode4(3227),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 15*/ GIMT_Encode4(3301),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 16*/ GIMT_Encode4(3349),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 17*/ GIMT_Encode4(3361),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 18*/ GIMT_Encode4(3373),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 19*/ GIMT_Encode4(3416),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 20*/ GIMT_Encode4(3449),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 21*/ GIMT_Encode4(3492), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 22*/ GIMT_Encode4(3556),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 23*/ GIMT_Encode4(3568),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 24*/ GIMT_Encode4(3580), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 25*/ GIMT_Encode4(3592), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  454 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(3604),
     /*  458 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(3732), GIMT_Encode4(0),
     /*  466 */ /*TargetOpcode::G_FCONSTANT*//*Label 28*/ GIMT_Encode4(4090), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  478 */ /*TargetOpcode::G_SEXT*//*Label 29*/ GIMT_Encode4(4102),
     /*  482 */ /*TargetOpcode::G_SEXT_INREG*//*Label 30*/ GIMT_Encode4(4177),
     /*  486 */ /*TargetOpcode::G_ZEXT*//*Label 31*/ GIMT_Encode4(4222),
     /*  490 */ /*TargetOpcode::G_SHL*//*Label 32*/ GIMT_Encode4(4352),
     /*  494 */ /*TargetOpcode::G_LSHR*//*Label 33*/ GIMT_Encode4(4521),
     /*  498 */ /*TargetOpcode::G_ASHR*//*Label 34*/ GIMT_Encode4(4644),
     /*  502 */ /*TargetOpcode::G_FSHL*//*Label 35*/ GIMT_Encode4(4778),
     /*  506 */ /*TargetOpcode::G_FSHR*//*Label 36*/ GIMT_Encode4(4821),
     /*  510 */ /*TargetOpcode::G_ROTR*//*Label 37*/ GIMT_Encode4(4864),
     /*  514 */ /*TargetOpcode::G_ROTL*//*Label 38*/ GIMT_Encode4(4888),
     /*  518 */ /*TargetOpcode::G_ICMP*//*Label 39*/ GIMT_Encode4(4912),
     /*  522 */ /*TargetOpcode::G_FCMP*//*Label 40*/ GIMT_Encode4(4968), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  534 */ /*TargetOpcode::G_SELECT*//*Label 41*/ GIMT_Encode4(4980),
     /*  538 */ /*TargetOpcode::G_UADDO*//*Label 42*/ GIMT_Encode4(5075),
     /*  542 */ /*TargetOpcode::G_UADDE*//*Label 43*/ GIMT_Encode4(5098),
     /*  546 */ /*TargetOpcode::G_USUBO*//*Label 44*/ GIMT_Encode4(5110),
     /*  550 */ /*TargetOpcode::G_USUBE*//*Label 45*/ GIMT_Encode4(5122),
     /*  554 */ /*TargetOpcode::G_SADDO*//*Label 46*/ GIMT_Encode4(5134),
     /*  558 */ /*TargetOpcode::G_SADDE*//*Label 47*/ GIMT_Encode4(5157),
     /*  562 */ /*TargetOpcode::G_SSUBO*//*Label 48*/ GIMT_Encode4(5169),
     /*  566 */ /*TargetOpcode::G_SSUBE*//*Label 49*/ GIMT_Encode4(5181),
     /*  570 */ /*TargetOpcode::G_UMULO*//*Label 50*/ GIMT_Encode4(5193),
     /*  574 */ /*TargetOpcode::G_SMULO*//*Label 51*/ GIMT_Encode4(5227),
     /*  578 */ /*TargetOpcode::G_UMULH*//*Label 52*/ GIMT_Encode4(5261),
     /*  582 */ /*TargetOpcode::G_SMULH*//*Label 53*/ GIMT_Encode4(5284),
     /*  586 */ /*TargetOpcode::G_UADDSAT*//*Label 54*/ GIMT_Encode4(5296),
     /*  590 */ /*TargetOpcode::G_SADDSAT*//*Label 55*/ GIMT_Encode4(5308), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  602 */ /*TargetOpcode::G_USHLSAT*//*Label 56*/ GIMT_Encode4(5320),
     /*  606 */ /*TargetOpcode::G_SSHLSAT*//*Label 57*/ GIMT_Encode4(5343),
     /*  610 */ /*TargetOpcode::G_SMULFIX*//*Label 58*/ GIMT_Encode4(5366),
     /*  614 */ /*TargetOpcode::G_UMULFIX*//*Label 59*/ GIMT_Encode4(5378),
     /*  618 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 60*/ GIMT_Encode4(5390),
     /*  622 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 61*/ GIMT_Encode4(5402), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  642 */ /*TargetOpcode::G_FADD*//*Label 62*/ GIMT_Encode4(5414),
     /*  646 */ /*TargetOpcode::G_FSUB*//*Label 63*/ GIMT_Encode4(5526),
     /*  650 */ /*TargetOpcode::G_FMUL*//*Label 64*/ GIMT_Encode4(5615),
     /*  654 */ /*TargetOpcode::G_FMA*//*Label 65*/ GIMT_Encode4(5703),
     /*  658 */ /*TargetOpcode::G_FMAD*//*Label 66*/ GIMT_Encode4(5726),
     /*  662 */ /*TargetOpcode::G_FDIV*//*Label 67*/ GIMT_Encode4(5749),
     /*  666 */ /*TargetOpcode::G_FREM*//*Label 68*/ GIMT_Encode4(5783), GIMT_Encode4(0),
     /*  674 */ /*TargetOpcode::G_FPOWI*//*Label 69*/ GIMT_Encode4(5795), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FLOG2*//*Label 70*/ GIMT_Encode4(5817), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  710 */ /*TargetOpcode::G_FNEG*//*Label 71*/ GIMT_Encode4(5839), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FPTRUNC*//*Label 72*/ GIMT_Encode4(5890),
     /*  722 */ /*TargetOpcode::G_FPTOSI*//*Label 73*/ GIMT_Encode4(5933),
     /*  726 */ /*TargetOpcode::G_FPTOUI*//*Label 74*/ GIMT_Encode4(5955),
     /*  730 */ /*TargetOpcode::G_SITOFP*//*Label 75*/ GIMT_Encode4(5977),
     /*  734 */ /*TargetOpcode::G_UITOFP*//*Label 76*/ GIMT_Encode4(6004), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  746 */ /*TargetOpcode::G_FABS*//*Label 77*/ GIMT_Encode4(6031), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  758 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 78*/ GIMT_Encode4(6110),
     /*  762 */ /*TargetOpcode::G_FMINNUM*//*Label 79*/ GIMT_Encode4(6140),
     /*  766 */ /*TargetOpcode::G_FMAXNUM*//*Label 80*/ GIMT_Encode4(6174),
     /*  770 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 81*/ GIMT_Encode4(6208),
     /*  774 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 82*/ GIMT_Encode4(6220),
     /*  778 */ /*TargetOpcode::G_FMINIMUM*//*Label 83*/ GIMT_Encode4(6232),
     /*  782 */ /*TargetOpcode::G_FMAXIMUM*//*Label 84*/ GIMT_Encode4(6266), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  810 */ /*TargetOpcode::G_PTR_ADD*//*Label 85*/ GIMT_Encode4(6300), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_SMIN*//*Label 86*/ GIMT_Encode4(6390),
     /*  822 */ /*TargetOpcode::G_SMAX*//*Label 87*/ GIMT_Encode4(6424),
     /*  826 */ /*TargetOpcode::G_UMIN*//*Label 88*/ GIMT_Encode4(6458),
     /*  830 */ /*TargetOpcode::G_UMAX*//*Label 89*/ GIMT_Encode4(6492),
     /*  834 */ /*TargetOpcode::G_ABS*//*Label 90*/ GIMT_Encode4(6526), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_BR*//*Label 91*/ GIMT_Encode4(6538), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  866 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(6550),
     /*  870 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 93*/ GIMT_Encode4(6680),
     /*  874 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 94*/ GIMT_Encode4(7057), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  914 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(7134), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  966 */ /*TargetOpcode::G_FSQRT*//*Label 96*/ GIMT_Encode4(7223), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 1110 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 97*/ GIMT_Encode4(7245),
     /* 1114 */ // Label 0: @1114
     /* 1114 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1125), // Rule ID 13 //
     /* 1119 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 1122 */   // MIs[0] d
     /* 1122 */   // No operand predicates
     /* 1122 */   // MIs[0] s
     /* 1122 */   // No operand predicates
     /* 1122 */   // Combiner Rule #13: copy_prop
     /* 1122 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1125 */ // Label 99: @1125
     /* 1125 */ GIM_Reject,
     /* 1126 */ // Label 1: @1126
     /* 1126 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1137), // Rule ID 16 //
     /* 1131 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1134 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1137 */ // Label 100: @1137
     /* 1137 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1148), // Rule ID 93 //
     /* 1142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1145 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1148 */ // Label 101: @1148
     /* 1148 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1159), // Rule ID 140 //
     /* 1153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 1156 */   // Combiner Rule #102: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 1159 */ // Label 102: @1159
     /* 1159 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1170), // Rule ID 229 //
     /* 1164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 1167 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1170 */ // Label 103: @1170
     /* 1170 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1181), // Rule ID 277 //
     /* 1175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 1178 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1181 */ // Label 104: @1181
     /* 1181 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1192), // Rule ID 306 //
     /* 1186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 1189 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1192 */ // Label 105: @1192
     /* 1192 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1226), // Rule ID 0 //
     /* 1197 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1200 */   // MIs[0] root
     /* 1200 */   // No operand predicates
     /* 1200 */   // MIs[0] sub
     /* 1200 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1208 */   // MIs[1] Operand 1
     /* 1208 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1212 */   // MIs[1] A
     /* 1212 */   // No operand predicates
     /* 1212 */   // MIs[0] B
     /* 1212 */   // No operand predicates
     /* 1212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1214 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1217 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1219 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1221 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1225 */   GIR_EraseRootFromParent_Done,
     /* 1226 */ // Label 106: @1226
     /* 1226 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1263), // Rule ID 12 //
     /* 1231 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1234 */   // MIs[0] root
     /* 1234 */   // No operand predicates
     /* 1234 */   // MIs[0] sub
     /* 1234 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1242 */   // MIs[1] A
     /* 1242 */   // No operand predicates
     /* 1242 */   // MIs[1] c1
     /* 1242 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1246 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1250 */   // MIs[2] imm1
     /* 1250 */   // No operand predicates
     /* 1250 */   // MIs[0] c2
     /* 1250 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1254 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1258 */   // MIs[3] imm2
     /* 1258 */   // No operand predicates
     /* 1258 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1260 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1260 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1263 */ // Label 107: @1263
     /* 1263 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1297), // Rule ID 3 //
     /* 1268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1271 */   // MIs[0] root
     /* 1271 */   // No operand predicates
     /* 1271 */   // MIs[0] sub
     /* 1271 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1279 */   // MIs[1] B
     /* 1279 */   // No operand predicates
     /* 1279 */   // MIs[1] A
     /* 1279 */   // No operand predicates
     /* 1279 */   // MIs[0] A
     /* 1279 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1284 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1291 */   // Combiner Rule #3: BMinusAPlusA
     /* 1291 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1296 */   GIR_EraseRootFromParent_Done,
     /* 1297 */ // Label 108: @1297
     /* 1297 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1331), // Rule ID 130 //
     /* 1302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1305 */   // MIs[0] dst
     /* 1305 */   // No operand predicates
     /* 1305 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1305 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1313 */   // MIs[1] src
     /* 1313 */   // No operand predicates
     /* 1313 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1313 */   // No operand predicates
     /* 1313 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1313 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1318 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1325 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1330 */   GIR_EraseRootFromParent_Done,
     /* 1331 */ // Label 109: @1331
     /* 1331 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1376), // Rule ID 5 //
     /* 1336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1339 */   // MIs[0] root
     /* 1339 */   // No operand predicates
     /* 1339 */   // MIs[0] sub1
     /* 1339 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1347 */   // MIs[1] A
     /* 1347 */   // No operand predicates
     /* 1347 */   // MIs[1] B
     /* 1347 */   // No operand predicates
     /* 1347 */   // MIs[0] sub2
     /* 1347 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1351 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1355 */   // MIs[2] B
     /* 1355 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1360 */   // MIs[2] C
     /* 1360 */   // No operand predicates
     /* 1360 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1362 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1365 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1367 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1371 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1375 */   GIR_EraseRootFromParent_Done,
     /* 1376 */ // Label 110: @1376
     /* 1376 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1421), // Rule ID 4 //
     /* 1381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1384 */   // MIs[0] root
     /* 1384 */   // No operand predicates
     /* 1384 */   // MIs[0] sub1
     /* 1384 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1392 */   // MIs[1] A
     /* 1392 */   // No operand predicates
     /* 1392 */   // MIs[1] B
     /* 1392 */   // No operand predicates
     /* 1392 */   // MIs[0] sub2
     /* 1392 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1396 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1400 */   // MIs[2] C
     /* 1400 */   // No operand predicates
     /* 1400 */   // MIs[2] A
     /* 1400 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1405 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1407 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1410 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1412 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1416 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1420 */   GIR_EraseRootFromParent_Done,
     /* 1421 */ // Label 111: @1421
     /* 1421 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1450), // Rule ID 368 //
     /* 1426 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 1429 */   // MIs[0] dst
     /* 1429 */   // No operand predicates
     /* 1429 */   // MIs[0] ext1
     /* 1429 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1437 */   // MIs[1] src1
     /* 1437 */   // No operand predicates
     /* 1437 */   // MIs[0] ext2
     /* 1437 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1441 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1445 */   // MIs[2] src2
     /* 1445 */   // No operand predicates
     /* 1445 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1447 */   // Combiner Rule #221: push_add_through_sext
     /* 1447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1450 */ // Label 112: @1450
     /* 1450 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1485), // Rule ID 39 //
     /* 1455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1458 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1464 */   // MIs[0] root
     /* 1464 */   // No operand predicates
     /* 1464 */   // MIs[0] left
     /* 1464 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1472 */   // MIs[1] imm1
     /* 1472 */   // No operand predicates
     /* 1472 */   // MIs[0] right
     /* 1472 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1476 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1480 */   // MIs[2] imm2
     /* 1480 */   // No operand predicates
     /* 1480 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1482 */   // Combiner Rule #37: add_of_vscale
     /* 1482 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1485 */ // Label 113: @1485
     /* 1485 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1514), // Rule ID 366 //
     /* 1490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 1493 */   // MIs[0] dst
     /* 1493 */   // No operand predicates
     /* 1493 */   // MIs[0] ext1
     /* 1493 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1501 */   // MIs[1] src1
     /* 1501 */   // No operand predicates
     /* 1501 */   // MIs[0] ext2
     /* 1501 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1505 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1509 */   // MIs[2] src2
     /* 1509 */   // No operand predicates
     /* 1509 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1511 */   // Combiner Rule #219: push_add_through_zext
     /* 1511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1514 */ // Label 114: @1514
     /* 1514 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1548), // Rule ID 1 //
     /* 1519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1522 */   // MIs[0] root
     /* 1522 */   // No operand predicates
     /* 1522 */   // MIs[0] A
     /* 1522 */   // No operand predicates
     /* 1522 */   // MIs[0] sub
     /* 1522 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1530 */   // MIs[1] Operand 1
     /* 1530 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1534 */   // MIs[1] B
     /* 1534 */   // No operand predicates
     /* 1534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1536 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1539 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1541 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1543 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1547 */   GIR_EraseRootFromParent_Done,
     /* 1548 */ // Label 115: @1548
     /* 1548 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1582), // Rule ID 2 //
     /* 1553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1556 */   // MIs[0] root
     /* 1556 */   // No operand predicates
     /* 1556 */   // MIs[0] A
     /* 1556 */   // No operand predicates
     /* 1556 */   // MIs[0] sub
     /* 1556 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1564 */   // MIs[1] B
     /* 1564 */   // No operand predicates
     /* 1564 */   // MIs[1] A
     /* 1564 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1569 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1576 */   // Combiner Rule #2: APlusBMinusB
     /* 1576 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1581 */   GIR_EraseRootFromParent_Done,
     /* 1582 */ // Label 116: @1582
     /* 1582 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1616), // Rule ID 129 //
     /* 1587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1590 */   // MIs[0] dst
     /* 1590 */   // No operand predicates
     /* 1590 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1590 */   // No operand predicates
     /* 1590 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1590 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1598 */   // MIs[1] src
     /* 1598 */   // No operand predicates
     /* 1598 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1598 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1603 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1610 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1610 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1615 */   GIR_EraseRootFromParent_Done,
     /* 1616 */ // Label 117: @1616
     /* 1616 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1661), // Rule ID 6 //
     /* 1621 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1624 */   // MIs[0] root
     /* 1624 */   // No operand predicates
     /* 1624 */   // MIs[0] A
     /* 1624 */   // No operand predicates
     /* 1624 */   // MIs[0] sub1
     /* 1624 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1632 */   // MIs[1] B
     /* 1632 */   // No operand predicates
     /* 1632 */   // MIs[1] add1
     /* 1632 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1636 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1640 */   // MIs[2] A
     /* 1640 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1645 */   // MIs[2] C
     /* 1645 */   // No operand predicates
     /* 1645 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1647 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1650 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1652 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1656 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1660 */   GIR_EraseRootFromParent_Done,
     /* 1661 */ // Label 118: @1661
     /* 1661 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1706), // Rule ID 7 //
     /* 1666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1669 */   // MIs[0] root
     /* 1669 */   // No operand predicates
     /* 1669 */   // MIs[0] A
     /* 1669 */   // No operand predicates
     /* 1669 */   // MIs[0] sub1
     /* 1669 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1677 */   // MIs[1] B
     /* 1677 */   // No operand predicates
     /* 1677 */   // MIs[1] add1
     /* 1677 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1681 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1685 */   // MIs[2] C
     /* 1685 */   // No operand predicates
     /* 1685 */   // MIs[2] A
     /* 1685 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1690 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1692 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1695 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1697 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1701 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1705 */   GIR_EraseRootFromParent_Done,
     /* 1706 */ // Label 119: @1706
     /* 1706 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1729), // Rule ID 104 //
     /* 1711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1714 */   // MIs[0] dst
     /* 1714 */   // No operand predicates
     /* 1714 */   // MIs[0] lhs
     /* 1714 */   // No operand predicates
     /* 1714 */   // MIs[0] Operand 2
     /* 1714 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1718 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1723 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1723 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1728 */   GIR_EraseRootFromParent_Done,
     /* 1729 */ // Label 120: @1729
     /* 1729 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1740), // Rule ID 148 //
     /* 1734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 1737 */   // MIs[0] root
     /* 1737 */   // No operand predicates
     /* 1737 */   // MIs[0] src1
     /* 1737 */   // No operand predicates
     /* 1737 */   // MIs[0] src2
     /* 1737 */   // No operand predicates
     /* 1737 */   // Combiner Rule #106: reassoc_comm_binops
     /* 1737 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 1740 */ // Label 121: @1740
     /* 1740 */ GIM_Reject,
     /* 1741 */ // Label 2: @1741
     /* 1741 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1752), // Rule ID 94 //
     /* 1746 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1749 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1749 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1752 */ // Label 122: @1752
     /* 1752 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1763), // Rule ID 237 //
     /* 1757 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 1760 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1760 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1763 */ // Label 123: @1763
     /* 1763 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1774), // Rule ID 278 //
     /* 1768 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 1771 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1771 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1774 */ // Label 124: @1774
     /* 1774 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1785), // Rule ID 303 //
     /* 1779 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1782 */   // Combiner Rule #185: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1785 */ // Label 125: @1785
     /* 1785 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1796), // Rule ID 337 //
     /* 1790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 1793 */   // Combiner Rule #192: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1793 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 1796 */ // Label 126: @1796
     /* 1796 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1833), // Rule ID 8 //
     /* 1801 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1804 */   // MIs[0] root
     /* 1804 */   // No operand predicates
     /* 1804 */   // MIs[0] add
     /* 1804 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1812 */   // MIs[1] A
     /* 1812 */   // No operand predicates
     /* 1812 */   // MIs[1] c1
     /* 1812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1816 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1820 */   // MIs[2] imm1
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[0] c2
     /* 1820 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1824 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1828 */   // MIs[3] imm2
     /* 1828 */   // No operand predicates
     /* 1828 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1830 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1833 */ // Label 127: @1833
     /* 1833 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1870), // Rule ID 11 //
     /* 1838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1841 */   // MIs[0] root
     /* 1841 */   // No operand predicates
     /* 1841 */   // MIs[0] sub1
     /* 1841 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1849 */   // MIs[1] c1
     /* 1849 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1853 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1857 */   // MIs[2] imm1
     /* 1857 */   // No operand predicates
     /* 1857 */   // MIs[1] A
     /* 1857 */   // No operand predicates
     /* 1857 */   // MIs[0] c2
     /* 1857 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1861 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1865 */   // MIs[3] imm2
     /* 1865 */   // No operand predicates
     /* 1865 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1867 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1867 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1870 */ // Label 128: @1870
     /* 1870 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1907), // Rule ID 10 //
     /* 1875 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1878 */   // MIs[0] root
     /* 1878 */   // No operand predicates
     /* 1878 */   // MIs[0] sub1
     /* 1878 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1886 */   // MIs[1] A
     /* 1886 */   // No operand predicates
     /* 1886 */   // MIs[1] c1
     /* 1886 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1890 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1894 */   // MIs[2] imm1
     /* 1894 */   // No operand predicates
     /* 1894 */   // MIs[0] c2
     /* 1894 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1898 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1902 */   // MIs[3] imm2
     /* 1902 */   // No operand predicates
     /* 1902 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1904 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1907 */ // Label 129: @1907
     /* 1907 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1936), // Rule ID 367 //
     /* 1912 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 1915 */   // MIs[0] dst
     /* 1915 */   // No operand predicates
     /* 1915 */   // MIs[0] ext1
     /* 1915 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1923 */   // MIs[1] src1
     /* 1923 */   // No operand predicates
     /* 1923 */   // MIs[0] ext2
     /* 1923 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1927 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1931 */   // MIs[2] src2
     /* 1931 */   // No operand predicates
     /* 1931 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1933 */   // Combiner Rule #220: push_sub_through_sext
     /* 1933 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1936 */ // Label 130: @1936
     /* 1936 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1965), // Rule ID 365 //
     /* 1941 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 1944 */   // MIs[0] dst
     /* 1944 */   // No operand predicates
     /* 1944 */   // MIs[0] ext1
     /* 1944 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1952 */   // MIs[1] src1
     /* 1952 */   // No operand predicates
     /* 1952 */   // MIs[0] ext2
     /* 1952 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1956 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1960 */   // MIs[2] src2
     /* 1960 */   // No operand predicates
     /* 1960 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1962 */   // Combiner Rule #218: push_sub_through_zext
     /* 1962 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1965 */ // Label 131: @1965
     /* 1965 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2002), // Rule ID 9 //
     /* 1970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1973 */   // MIs[0] root
     /* 1973 */   // No operand predicates
     /* 1973 */   // MIs[0] c2
     /* 1973 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1981 */   // MIs[1] imm2
     /* 1981 */   // No operand predicates
     /* 1981 */   // MIs[0] add
     /* 1981 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1985 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1989 */   // MIs[2] A
     /* 1989 */   // No operand predicates
     /* 1989 */   // MIs[2] c1
     /* 1989 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 1993 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1997 */   // MIs[3] imm1
     /* 1997 */   // No operand predicates
     /* 1997 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1999 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 1999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2002 */ // Label 132: @2002
     /* 2002 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2029), // Rule ID 42 //
     /* 2007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 2010 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2016 */   // MIs[0] root
     /* 2016 */   // No operand predicates
     /* 2016 */   // MIs[0] x
     /* 2016 */   // No operand predicates
     /* 2016 */   // MIs[0] right
     /* 2016 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2024 */   // MIs[1] imm
     /* 2024 */   // No operand predicates
     /* 2024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026 */   // Combiner Rule #40: sub_of_vscale
     /* 2026 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2029 */ // Label 133: @2029
     /* 2029 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2052), // Rule ID 103 //
     /* 2034 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2037 */   // MIs[0] dst
     /* 2037 */   // No operand predicates
     /* 2037 */   // MIs[0] lhs
     /* 2037 */   // No operand predicates
     /* 2037 */   // MIs[0] Operand 2
     /* 2037 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2041 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2046 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 2046 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2051 */   GIR_EraseRootFromParent_Done,
     /* 2052 */ // Label 134: @2052
     /* 2052 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2073), // Rule ID 15 //
     /* 2057 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2060 */   // MIs[0] d
     /* 2060 */   // No operand predicates
     /* 2060 */   // MIs[0] op1
     /* 2060 */   // No operand predicates
     /* 2060 */   // MIs[0] c
     /* 2060 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2068 */   // MIs[1] imm
     /* 2068 */   // No operand predicates
     /* 2068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2070 */   // Combiner Rule #15: sub_to_add
     /* 2070 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2073 */ // Label 135: @2073
     /* 2073 */ GIM_Reject,
     /* 2074 */ // Label 3: @2074
     /* 2074 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2085), // Rule ID 77 //
     /* 2079 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2082 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 2082 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 2085 */ // Label 136: @2085
     /* 2085 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2096), // Rule ID 234 //
     /* 2090 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2093 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 2093 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2096 */ // Label 137: @2096
     /* 2096 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2107), // Rule ID 307 //
     /* 2101 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 2104 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 2104 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2107 */ // Label 138: @2107
     /* 2107 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2147), // Rule ID 17 //
     /* 2112 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2115 */   // MIs[0] dst
     /* 2115 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 2119 */   // MIs[0] x
     /* 2119 */   // No operand predicates
     /* 2119 */   // MIs[0] Operand 2
     /* 2119 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 2123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2126 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 2136 */   // Combiner Rule #17: mul_by_neg_one
     /* 2136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 2139 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2144 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 2146 */   GIR_EraseRootFromParent_Done,
     /* 2147 */ // Label 139: @2147
     /* 2147 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2182), // Rule ID 40 //
     /* 2152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 2155 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2161 */   // MIs[0] root
     /* 2161 */   // No operand predicates
     /* 2161 */   // MIs[0] left
     /* 2161 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2169 */   // MIs[1] scale
     /* 2169 */   // No operand predicates
     /* 2169 */   // MIs[0] x
     /* 2169 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2173 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2177 */   // MIs[2] imm1
     /* 2177 */   // No operand predicates
     /* 2177 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2179 */   // Combiner Rule #38: mul_of_vscale
     /* 2179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 2182 */ // Label 140: @2182
     /* 2182 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2205), // Rule ID 122 //
     /* 2187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2190 */   // MIs[0] dst
     /* 2190 */   // No operand predicates
     /* 2190 */   // MIs[0] lhs
     /* 2190 */   // No operand predicates
     /* 2190 */   // MIs[0] zero
     /* 2190 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2194 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2199 */   // Combiner Rule #86: binop_right_to_zero
     /* 2199 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2204 */   GIR_EraseRootFromParent_Done,
     /* 2205 */ // Label 141: @2205
     /* 2205 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2228), // Rule ID 127 //
     /* 2210 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 2213 */   // MIs[0] dst
     /* 2213 */   // No operand predicates
     /* 2213 */   // MIs[0] x
     /* 2213 */   // No operand predicates
     /* 2213 */   // MIs[0] Operand 2
     /* 2213 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2217 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2222 */   // Combiner Rule #91: right_identity_one_int
     /* 2222 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2227 */   GIR_EraseRootFromParent_Done,
     /* 2228 */ // Label 142: @2228
     /* 2228 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2239), // Rule ID 14 //
     /* 2233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2236 */   // MIs[0] d
     /* 2236 */   // No operand predicates
     /* 2236 */   // MIs[0] op1
     /* 2236 */   // No operand predicates
     /* 2236 */   // MIs[0] op2
     /* 2236 */   // No operand predicates
     /* 2236 */   // Combiner Rule #14: mul_to_shl
     /* 2236 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2239 */ // Label 143: @2239
     /* 2239 */ GIM_Reject,
     /* 2240 */ // Label 4: @2240
     /* 2240 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2251), // Rule ID 118 //
     /* 2245 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2248 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2248 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2251 */ // Label 144: @2251
     /* 2251 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2262), // Rule ID 209 //
     /* 2256 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2259 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2262 */ // Label 145: @2262
     /* 2262 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2273), // Rule ID 240 //
     /* 2267 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2270 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2270 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2273 */ // Label 146: @2273
     /* 2273 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2284), // Rule ID 258 //
     /* 2278 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 2281 */   // Combiner Rule #170: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2281 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2284 */ // Label 147: @2284
     /* 2284 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2295), // Rule ID 283 //
     /* 2289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2292 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2295 */ // Label 148: @2295
     /* 2295 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2312), // Rule ID 259 //
     /* 2300 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2303 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2309 */   // MIs[0] dst
     /* 2309 */   // No operand predicates
     /* 2309 */   // MIs[0] x
     /* 2309 */   // No operand predicates
     /* 2309 */   // MIs[0] y
     /* 2309 */   // No operand predicates
     /* 2309 */   // Combiner Rule #171: sdiv_by_pow2
     /* 2309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2312 */ // Label 149: @2312
     /* 2312 */ GIM_Reject,
     /* 2313 */ // Label 5: @2313
     /* 2313 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2324), // Rule ID 80 //
     /* 2318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2321 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2324 */ // Label 150: @2324
     /* 2324 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2335), // Rule ID 119 //
     /* 2329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2332 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2332 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2335 */ // Label 151: @2335
     /* 2335 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2346), // Rule ID 210 //
     /* 2340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2343 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2346 */ // Label 152: @2346
     /* 2346 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2357), // Rule ID 239 //
     /* 2351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2354 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2357 */ // Label 153: @2357
     /* 2357 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2368), // Rule ID 257 //
     /* 2362 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 2365 */   // Combiner Rule #169: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2365 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 2368 */ // Label 154: @2368
     /* 2368 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2379), // Rule ID 285 //
     /* 2373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2376 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2376 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2379 */ // Label 155: @2379
     /* 2379 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2396), // Rule ID 260 //
     /* 2384 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2387 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2393 */   // MIs[0] dst
     /* 2393 */   // No operand predicates
     /* 2393 */   // MIs[0] x
     /* 2393 */   // No operand predicates
     /* 2393 */   // MIs[0] y
     /* 2393 */   // No operand predicates
     /* 2393 */   // Combiner Rule #172: udiv_by_pow2
     /* 2393 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2396 */ // Label 156: @2396
     /* 2396 */ GIM_Reject,
     /* 2397 */ // Label 6: @2397
     /* 2397 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2408), // Rule ID 120 //
     /* 2402 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2405 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2405 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2408 */ // Label 157: @2408
     /* 2408 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2419), // Rule ID 211 //
     /* 2413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2416 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2416 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2419 */ // Label 158: @2419
     /* 2419 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2430), // Rule ID 242 //
     /* 2424 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2427 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2430 */ // Label 159: @2430
     /* 2430 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2441), // Rule ID 284 //
     /* 2435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2438 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2438 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2441 */ // Label 160: @2441
     /* 2441 */ GIM_Reject,
     /* 2442 */ // Label 7: @2442
     /* 2442 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2453), // Rule ID 81 //
     /* 2447 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2450 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2450 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2453 */ // Label 161: @2453
     /* 2453 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2464), // Rule ID 121 //
     /* 2458 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2461 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2461 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2464 */ // Label 162: @2464
     /* 2464 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2475), // Rule ID 168 //
     /* 2469 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 2472 */   // Combiner Rule #126: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2472 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2475 */ // Label 163: @2475
     /* 2475 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2486), // Rule ID 212 //
     /* 2480 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2483 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2483 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2486 */ // Label 164: @2486
     /* 2486 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2497), // Rule ID 241 //
     /* 2491 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2494 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2494 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2497 */ // Label 165: @2497
     /* 2497 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2508), // Rule ID 286 //
     /* 2502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2505 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2508 */ // Label 166: @2508
     /* 2508 */ GIM_Reject,
     /* 2509 */ // Label 8: @2509
     /* 2509 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2520), // Rule ID 72 //
     /* 2514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 2517 */   // Combiner Rule #68: load_and_mask; wip_match_opcode 'G_AND'
     /* 2517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 2520 */ // Label 167: @2520
     /* 2520 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2531), // Rule ID 76 //
     /* 2525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2528 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2528 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 2531 */ // Label 168: @2531
     /* 2531 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2542), // Rule ID 141 //
     /* 2536 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2539 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2539 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2542 */ // Label 169: @2542
     /* 2542 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2553), // Rule ID 160 //
     /* 2547 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 2550 */   // Combiner Rule #118: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2550 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2553 */ // Label 170: @2553
     /* 2553 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2564), // Rule ID 165 //
     /* 2558 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 2561 */   // Combiner Rule #123: redundant_and; wip_match_opcode 'G_AND'
     /* 2561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 2564 */ // Label 171: @2564
     /* 2564 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2575), // Rule ID 182 //
     /* 2569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 2572 */   // Combiner Rule #140: overlapping_and; wip_match_opcode 'G_AND'
     /* 2572 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 2575 */ // Label 172: @2575
     /* 2575 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2586), // Rule ID 231 //
     /* 2580 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2583 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2583 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2586 */ // Label 173: @2586
     /* 2586 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2597), // Rule ID 268 //
     /* 2591 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 2594 */   // Combiner Rule #175: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2594 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 2597 */ // Label 174: @2597
     /* 2597 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2608), // Rule ID 280 //
     /* 2602 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2605 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2605 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2608 */ // Label 175: @2608
     /* 2608 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2619), // Rule ID 308 //
     /* 2613 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 2616 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2616 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2619 */ // Label 176: @2619
     /* 2619 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2630), // Rule ID 335 //
     /* 2624 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2627 */   // Combiner Rule #190: match_ands; wip_match_opcode 'G_AND'
     /* 2627 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 2630 */ // Label 177: @2630
     /* 2630 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2728), // Rule ID 154 //
     /* 2635 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 2638 */   // MIs[0] root
     /* 2638 */   // No operand predicates
     /* 2638 */   // MIs[0] d1
     /* 2638 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2646 */   // MIs[1] p
     /* 2646 */   // No operand predicates
     /* 2646 */   // MIs[1] s1
     /* 2646 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2650 */   // MIs[1] Operand 3
     /* 2650 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2654 */   // MIs[0] d2
     /* 2654 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2658 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2662 */   // MIs[2] p
     /* 2662 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2667 */   // MIs[2] s2
     /* 2667 */   // No operand predicates
     /* 2667 */   // MIs[2] Operand 3
     /* 2667 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2671 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2675 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2677 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2680 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2693 */   // Combiner Rule #112: double_icmp_zero_and_combine
     /* 2693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2696 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2701 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2705 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2713 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2721 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2724 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2727 */   GIR_EraseRootFromParent_Done,
     /* 2728 */ // Label 178: @2728
     /* 2728 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2765), // Rule ID 224 //
     /* 2733 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 2736 */   // MIs[0] root
     /* 2736 */   // No operand predicates
     /* 2736 */   // MIs[0] shift
     /* 2736 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2740 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2744 */   // MIs[1] x
     /* 2744 */   // No operand predicates
     /* 2744 */   // MIs[1] lsb
     /* 2744 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2748 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2752 */   // MIs[2] imm1
     /* 2752 */   // No operand predicates
     /* 2752 */   // MIs[0] mask
     /* 2752 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2756 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2760 */   // MIs[3] imm2
     /* 2760 */   // No operand predicates
     /* 2760 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2762 */   // Combiner Rule #161: bitfield_extract_from_and
     /* 2762 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 2765 */ // Label 179: @2765
     /* 2765 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2789), // Rule ID 113 //
     /* 2770 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2773 */   // MIs[0] dst
     /* 2773 */   // No operand predicates
     /* 2773 */   // MIs[0] src
     /* 2773 */   // No operand predicates
     /* 2773 */   // MIs[0] src
     /* 2773 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2778 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2783 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2783 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2788 */   GIR_EraseRootFromParent_Done,
     /* 2789 */ // Label 180: @2789
     /* 2789 */ GIM_Reject,
     /* 2790 */ // Label 9: @2790
     /* 2790 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2801), // Rule ID 78 //
     /* 2795 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2798 */   // Combiner Rule #72: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2801 */ // Label 181: @2801
     /* 2801 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2812), // Rule ID 142 //
     /* 2806 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2809 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2809 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2812 */ // Label 182: @2812
     /* 2812 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2823), // Rule ID 167 //
     /* 2817 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2820 */   // Combiner Rule #125: redundant_or; wip_match_opcode 'G_OR'
     /* 2820 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 2823 */ // Label 183: @2823
     /* 2823 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2834), // Rule ID 208 //
     /* 2828 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 2831 */   // Combiner Rule #150: load_or_combine; wip_match_opcode 'G_OR'
     /* 2831 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 2834 */ // Label 184: @2834
     /* 2834 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2845), // Rule ID 213 //
     /* 2839 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2842 */   // Combiner Rule #152: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2845 */ // Label 185: @2845
     /* 2845 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2856), // Rule ID 235 //
     /* 2850 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2853 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2853 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2856 */ // Label 186: @2856
     /* 2856 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2867), // Rule ID 281 //
     /* 2861 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2864 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2867 */ // Label 187: @2867
     /* 2867 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2878), // Rule ID 309 //
     /* 2872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 2875 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2875 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2878 */ // Label 188: @2878
     /* 2878 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2889), // Rule ID 336 //
     /* 2883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2886 */   // Combiner Rule #191: match_ors; wip_match_opcode 'G_OR'
     /* 2886 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2889 */ // Label 189: @2889
     /* 2889 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2987), // Rule ID 155 //
     /* 2894 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2897 */   // MIs[0] root
     /* 2897 */   // No operand predicates
     /* 2897 */   // MIs[0] d1
     /* 2897 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2905 */   // MIs[1] p
     /* 2905 */   // No operand predicates
     /* 2905 */   // MIs[1] s1
     /* 2905 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2909 */   // MIs[1] Operand 3
     /* 2909 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2913 */   // MIs[0] d2
     /* 2913 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2917 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2921 */   // MIs[2] p
     /* 2921 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2926 */   // MIs[2] s2
     /* 2926 */   // No operand predicates
     /* 2926 */   // MIs[2] Operand 3
     /* 2926 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2930 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2934 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2936 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2939 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2952 */   // Combiner Rule #113: double_icmp_zero_or_combine
     /* 2952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2955 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2960 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2964 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2972 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2976 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2980 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2983 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2986 */   GIR_EraseRootFromParent_Done,
     /* 2987 */ // Label 190: @2987
     /* 2987 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3011), // Rule ID 114 //
     /* 2992 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2995 */   // MIs[0] dst
     /* 2995 */   // No operand predicates
     /* 2995 */   // MIs[0] src
     /* 2995 */   // No operand predicates
     /* 2995 */   // MIs[0] src
     /* 2995 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 3000 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3005 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 3005 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3010 */   GIR_EraseRootFromParent_Done,
     /* 3011 */ // Label 191: @3011
     /* 3011 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3034), // Rule ID 105 //
     /* 3016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3019 */   // MIs[0] dst
     /* 3019 */   // No operand predicates
     /* 3019 */   // MIs[0] lhs
     /* 3019 */   // No operand predicates
     /* 3019 */   // MIs[0] Operand 2
     /* 3019 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3023 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3028 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 3028 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3033 */   GIR_EraseRootFromParent_Done,
     /* 3034 */ // Label 192: @3034
     /* 3034 */ GIM_Reject,
     /* 3035 */ // Label 10: @3035
     /* 3035 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3046), // Rule ID 95 //
     /* 3040 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3043 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 3043 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3046 */ // Label 193: @3046
     /* 3046 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3057), // Rule ID 143 //
     /* 3051 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 3054 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 3054 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 3057 */ // Label 194: @3057
     /* 3057 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3068), // Rule ID 172 //
     /* 3062 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 3065 */   // Combiner Rule #130: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 3065 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3068 */ // Label 195: @3068
     /* 3068 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3079), // Rule ID 196 //
     /* 3073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 3076 */   // Combiner Rule #146: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 3076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 3079 */ // Label 196: @3079
     /* 3079 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3090), // Rule ID 238 //
     /* 3084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 3087 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 3087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 3090 */ // Label 197: @3090
     /* 3090 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3101), // Rule ID 282 //
     /* 3095 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 3098 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 3098 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 3101 */ // Label 198: @3101
     /* 3101 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3112), // Rule ID 310 //
     /* 3106 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 3109 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 3109 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 3112 */ // Label 199: @3112
     /* 3112 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3135), // Rule ID 106 //
     /* 3117 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3120 */   // MIs[0] dst
     /* 3120 */   // No operand predicates
     /* 3120 */   // MIs[0] lhs
     /* 3120 */   // No operand predicates
     /* 3120 */   // MIs[0] Operand 2
     /* 3120 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3124 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3129 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 3129 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3134 */   GIR_EraseRootFromParent_Done,
     /* 3135 */ // Label 200: @3135
     /* 3135 */ GIM_Reject,
     /* 3136 */ // Label 11: @3136
     /* 3136 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3147), // Rule ID 139 //
     /* 3141 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 3144 */   // Combiner Rule #101: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 3144 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3147 */ // Label 201: @3147
     /* 3147 */ GIM_Reject,
     /* 3148 */ // Label 12: @3148
     /* 3148 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3159), // Rule ID 361 //
     /* 3153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 3156 */   // Combiner Rule #214: fold_global_offset; wip_match_opcode 'G_GLOBAL_VALUE'
     /* 3156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 3159 */ // Label 202: @3159
     /* 3159 */ GIM_Reject,
     /* 3160 */ // Label 13: @3160
     /* 3160 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3171), // Rule ID 346 //
     /* 3165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 3168 */   // Combiner Rule #201: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3171 */ // Label 203: @3171
     /* 3171 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3182), // Rule ID 347 //
     /* 3176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 3179 */   // Combiner Rule #202: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 3182 */ // Label 204: @3182
     /* 3182 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3193), // Rule ID 349 //
     /* 3187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3190 */   // Combiner Rule #204: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3193 */ // Label 205: @3193
     /* 3193 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3204), // Rule ID 350 //
     /* 3198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3201 */   // Combiner Rule #205: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 3204 */ // Label 206: @3204
     /* 3204 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3215), // Rule ID 351 //
     /* 3209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 3212 */   // Combiner Rule #206: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 3215 */ // Label 207: @3215
     /* 3215 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3226), // Rule ID 352 //
     /* 3220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 3223 */   // Combiner Rule #207: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3226 */ // Label 208: @3226
     /* 3226 */ GIM_Reject,
     /* 3227 */ // Label 14: @3227
     /* 3227 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3238), // Rule ID 348 //
     /* 3232 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 3235 */   // Combiner Rule #203: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3235 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3238 */ // Label 209: @3238
     /* 3238 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3300),
     /* 3243 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3246 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3267), // Rule ID 353 //
     /* 3251 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 3254 */     // MIs[0] root
     /* 3254 */     // No operand predicates
     /* 3254 */     // MIs[0] x
     /* 3254 */     // No operand predicates
     /* 3254 */     // MIs[0] undef
     /* 3254 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3264 */     // Combiner Rule #208: merge_of_x_and_undef
     /* 3264 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3267 */   // Label 211: @3267
     /* 3267 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3299), // Rule ID 354 //
     /* 3272 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3275 */     // MIs[0] root
     /* 3275 */     // No operand predicates
     /* 3275 */     // MIs[0] x
     /* 3275 */     // No operand predicates
     /* 3275 */     // MIs[0] zero
     /* 3275 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3283 */     // MIs[1] Operand 1
     /* 3283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3296 */     // Combiner Rule #209: merge_of_x_and_zero
     /* 3296 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3299 */   // Label 212: @3299
     /* 3299 */   GIM_Reject,
     /* 3300 */ // Label 210: @3300
     /* 3300 */ GIM_Reject,
     /* 3301 */ // Label 15: @3301
     /* 3301 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3312), // Rule ID 68 //
     /* 3306 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3309 */   // Combiner Rule #66: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 3312 */ // Label 213: @3312
     /* 3312 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3323), // Rule ID 97 //
     /* 3317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3320 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3320 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3323 */ // Label 214: @3323
     /* 3323 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3334), // Rule ID 132 //
     /* 3328 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3331 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3331 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3334 */ // Label 215: @3334
     /* 3334 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3348), // Rule ID 345 //
     /* 3339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 3342 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3345 */   // MIs[0] dst
     /* 3345 */   // No operand predicates
     /* 3345 */   // MIs[0] unused
     /* 3345 */   // No operand predicates
     /* 3345 */   // Combiner Rule #200: combine_use_vector_truncate
     /* 3345 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 3348 */ // Label 216: @3348
     /* 3348 */ GIM_Reject,
     /* 3349 */ // Label 16: @3349
     /* 3349 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3360), // Rule ID 131 //
     /* 3354 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3357 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3357 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3360 */ // Label 217: @3360
     /* 3360 */ GIM_Reject,
     /* 3361 */ // Label 17: @3361
     /* 3361 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3372), // Rule ID 338 //
     /* 3366 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 3369 */   // Combiner Rule #193: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3369 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 3372 */ // Label 218: @3372
     /* 3372 */ GIM_Reject,
     /* 3373 */ // Label 18: @3373
     /* 3373 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3394), // Rule ID 124 //
     /* 3378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3381 */   // MIs[0] dst
     /* 3381 */   // No operand predicates
     /* 3381 */   // MIs[0] t
     /* 3381 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3389 */   // MIs[1] ptr
     /* 3389 */   // No operand predicates
     /* 3389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3391 */   // Combiner Rule #88: i2p_to_p2i
     /* 3391 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3394 */ // Label 219: @3394
     /* 3394 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3415), // Rule ID 89 //
     /* 3399 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3402 */   // MIs[0] dst
     /* 3402 */   // No operand predicates
     /* 3402 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3402 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3410 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3412 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3412 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3415 */ // Label 220: @3415
     /* 3415 */ GIM_Reject,
     /* 3416 */ // Label 19: @3416
     /* 3416 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3427), // Rule ID 123 //
     /* 3421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3424 */   // Combiner Rule #87: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3424 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 3427 */ // Label 221: @3427
     /* 3427 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3448), // Rule ID 90 //
     /* 3432 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3435 */   // MIs[0] dst
     /* 3435 */   // No operand predicates
     /* 3435 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3435 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3445 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3445 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3448 */ // Label 222: @3448
     /* 3448 */ GIM_Reject,
     /* 3449 */ // Label 20: @3449
     /* 3449 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3470), // Rule ID 135 //
     /* 3454 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3457 */   // MIs[0] dst
     /* 3457 */   // No operand predicates
     /* 3457 */   // MIs[0] src1
     /* 3457 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3465 */   // MIs[1] src0
     /* 3465 */   // No operand predicates
     /* 3465 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3467 */   // Combiner Rule #97: bitcast_bitcast_fold
     /* 3467 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3470 */ // Label 223: @3470
     /* 3470 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3491), // Rule ID 87 //
     /* 3475 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3478 */   // MIs[0] dst
     /* 3478 */   // No operand predicates
     /* 3478 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3478 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3486 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3488 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3491 */ // Label 224: @3491
     /* 3491 */ GIM_Reject,
     /* 3492 */ // Label 21: @3492
     /* 3492 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3521), // Rule ID 18 //
     /* 3497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3500 */   // MIs[0] dst
     /* 3500 */   // No operand predicates
     /* 3500 */   // MIs[0] src
     /* 3500 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3508 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3508 */   // No operand predicates
     /* 3508 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3513 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3515 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3515 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3520 */   GIR_EraseRootFromParent_Done,
     /* 3521 */ // Label 225: @3521
     /* 3521 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3544), // Rule ID 43 //
     /* 3526 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3529 */   // MIs[0] root
     /* 3529 */   // No operand predicates
     /* 3529 */   // MIs[0] src
     /* 3529 */   // No operand predicates
     /* 3529 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3533 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3538 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3538 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3543 */   GIR_EraseRootFromParent_Done,
     /* 3544 */ // Label 226: @3544
     /* 3544 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3555), // Rule ID 44 //
     /* 3549 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3552 */   // MIs[0] dst
     /* 3552 */   // No operand predicates
     /* 3552 */   // MIs[0] src
     /* 3552 */   // No operand predicates
     /* 3552 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3552 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3555 */ // Label 227: @3555
     /* 3555 */ GIM_Reject,
     /* 3556 */ // Label 22: @3556
     /* 3556 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3567), // Rule ID 69 //
     /* 3561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3564 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3564 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3567 */ // Label 228: @3567
     /* 3567 */ GIM_Reject,
     /* 3568 */ // Label 23: @3568
     /* 3568 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3579), // Rule ID 70 //
     /* 3573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3576 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3579 */ // Label 229: @3579
     /* 3579 */ GIM_Reject,
     /* 3580 */ // Label 24: @3580
     /* 3580 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3591), // Rule ID 71 //
     /* 3585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3588 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3588 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3591 */ // Label 230: @3591
     /* 3591 */ GIM_Reject,
     /* 3592 */ // Label 25: @3592
     /* 3592 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3603), // Rule ID 99 //
     /* 3597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3600 */   // Combiner Rule #80: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3600 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 3603 */ // Label 231: @3603
     /* 3603 */ GIM_Reject,
     /* 3604 */ // Label 26: @3604
     /* 3604 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3615), // Rule ID 125 //
     /* 3609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3612 */   // Combiner Rule #89: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3615 */ // Label 232: @3615
     /* 3615 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3626), // Rule ID 255 //
     /* 3620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 3623 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3626 */ // Label 233: @3626
     /* 3626 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3647), // Rule ID 56 //
     /* 3631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 3634 */   // MIs[0] root
     /* 3634 */   // No operand predicates
     /* 3634 */   // MIs[0] select
     /* 3634 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3638 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3642 */   // MIs[1] cond
     /* 3642 */   // No operand predicates
     /* 3642 */   // MIs[1] true
     /* 3642 */   // No operand predicates
     /* 3642 */   // MIs[1] false
     /* 3642 */   // No operand predicates
     /* 3642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3644 */   // Combiner Rule #54: select_of_anyext
     /* 3644 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3647 */ // Label 234: @3647
     /* 3647 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3668), // Rule ID 52 //
     /* 3652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3655 */   // MIs[0] root
     /* 3655 */   // No operand predicates
     /* 3655 */   // MIs[0] second
     /* 3655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3663 */   // MIs[1] src
     /* 3663 */   // No operand predicates
     /* 3663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3665 */   // Combiner Rule #50: anyext_of_anyext
     /* 3665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3668 */ // Label 235: @3668
     /* 3668 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3689), // Rule ID 54 //
     /* 3673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3676 */   // MIs[0] root
     /* 3676 */   // No operand predicates
     /* 3676 */   // MIs[0] second
     /* 3676 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3684 */   // MIs[1] src
     /* 3684 */   // No operand predicates
     /* 3684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3686 */   // Combiner Rule #52: anyext_of_sext
     /* 3686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3689 */ // Label 236: @3689
     /* 3689 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3710), // Rule ID 53 //
     /* 3694 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3697 */   // MIs[0] root
     /* 3697 */   // No operand predicates
     /* 3697 */   // MIs[0] second
     /* 3697 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3705 */   // MIs[1] src
     /* 3705 */   // No operand predicates
     /* 3705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3707 */   // Combiner Rule #51: anyext_of_zext
     /* 3707 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3710 */ // Label 237: @3710
     /* 3710 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3731), // Rule ID 88 //
     /* 3715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3718 */   // MIs[0] dst
     /* 3718 */   // No operand predicates
     /* 3718 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3718 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3728 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3728 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3731 */ // Label 238: @3731
     /* 3731 */ GIM_Reject,
     /* 3732 */ // Label 27: @3732
     /* 3732 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3743), // Rule ID 133 //
     /* 3737 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3740 */   // Combiner Rule #95: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3740 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3743 */ // Label 239: @3743
     /* 3743 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3754), // Rule ID 134 //
     /* 3748 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3751 */   // Combiner Rule #96: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3751 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3754 */ // Label 240: @3754
     /* 3754 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3765), // Rule ID 171 //
     /* 3759 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 3762 */   // Combiner Rule #129: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3762 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 3765 */ // Label 241: @3765
     /* 3765 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3786), // Rule ID 57 //
     /* 3770 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3773 */   // MIs[0] root
     /* 3773 */   // No operand predicates
     /* 3773 */   // MIs[0] select
     /* 3773 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3781 */   // MIs[1] cond
     /* 3781 */   // No operand predicates
     /* 3781 */   // MIs[1] true
     /* 3781 */   // No operand predicates
     /* 3781 */   // MIs[1] false
     /* 3781 */   // No operand predicates
     /* 3781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3783 */   // Combiner Rule #55: select_of_truncate
     /* 3783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3786 */ // Label 242: @3786
     /* 3786 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3815), // Rule ID 59 //
     /* 3791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3794 */   // MIs[0] root
     /* 3794 */   // No operand predicates
     /* 3794 */   // MIs[0] binop
     /* 3794 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3802 */   // MIs[1] x
     /* 3802 */   // No operand predicates
     /* 3802 */   // MIs[1] const
     /* 3802 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3806 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3810 */   // MIs[2] imm
     /* 3810 */   // No operand predicates
     /* 3810 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3812 */   // Combiner Rule #57: narrow_binop_add
     /* 3812 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3815 */ // Label 243: @3815
     /* 3815 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3844), // Rule ID 62 //
     /* 3820 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3823 */   // MIs[0] root
     /* 3823 */   // No operand predicates
     /* 3823 */   // MIs[0] binop
     /* 3823 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3827 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3831 */   // MIs[1] x
     /* 3831 */   // No operand predicates
     /* 3831 */   // MIs[1] const
     /* 3831 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3835 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3839 */   // MIs[2] imm
     /* 3839 */   // No operand predicates
     /* 3839 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3841 */   // Combiner Rule #60: narrow_binop_and
     /* 3841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3844 */ // Label 244: @3844
     /* 3844 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3873), // Rule ID 61 //
     /* 3849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3852 */   // MIs[0] root
     /* 3852 */   // No operand predicates
     /* 3852 */   // MIs[0] binop
     /* 3852 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3860 */   // MIs[1] x
     /* 3860 */   // No operand predicates
     /* 3860 */   // MIs[1] const
     /* 3860 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3864 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3868 */   // MIs[2] imm
     /* 3868 */   // No operand predicates
     /* 3868 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3870 */   // Combiner Rule #59: narrow_binop_mul
     /* 3870 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3873 */ // Label 245: @3873
     /* 3873 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3902), // Rule ID 63 //
     /* 3878 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3881 */   // MIs[0] root
     /* 3881 */   // No operand predicates
     /* 3881 */   // MIs[0] binop
     /* 3881 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3889 */   // MIs[1] x
     /* 3889 */   // No operand predicates
     /* 3889 */   // MIs[1] const
     /* 3889 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3893 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3897 */   // MIs[2] imm
     /* 3897 */   // No operand predicates
     /* 3897 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3899 */   // Combiner Rule #61: narrow_binop_or
     /* 3899 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3902 */ // Label 246: @3902
     /* 3902 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3931), // Rule ID 60 //
     /* 3907 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3910 */   // MIs[0] root
     /* 3910 */   // No operand predicates
     /* 3910 */   // MIs[0] binop
     /* 3910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3918 */   // MIs[1] x
     /* 3918 */   // No operand predicates
     /* 3918 */   // MIs[1] const
     /* 3918 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3922 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3926 */   // MIs[2] imm
     /* 3926 */   // No operand predicates
     /* 3926 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3928 */   // Combiner Rule #58: narrow_binop_sub
     /* 3928 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3931 */ // Label 247: @3931
     /* 3931 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3960), // Rule ID 64 //
     /* 3936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3939 */   // MIs[0] root
     /* 3939 */   // No operand predicates
     /* 3939 */   // MIs[0] binop
     /* 3939 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3947 */   // MIs[1] x
     /* 3947 */   // No operand predicates
     /* 3947 */   // MIs[1] const
     /* 3947 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3955 */   // MIs[2] imm
     /* 3955 */   // No operand predicates
     /* 3955 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3957 */   // Combiner Rule #62: narrow_binop_xor
     /* 3957 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3960 */ // Label 248: @3960
     /* 3960 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3981), // Rule ID 47 //
     /* 3965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 3968 */   // MIs[0] root
     /* 3968 */   // No operand predicates
     /* 3968 */   // MIs[0] ext
     /* 3968 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3976 */   // MIs[1] src
     /* 3976 */   // No operand predicates
     /* 3976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3978 */   // Combiner Rule #45: truncate_of_anyext
     /* 3978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3981 */ // Label 249: @3981
     /* 3981 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4005), // Rule ID 58 //
     /* 3986 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3989 */   // MIs[0] root
     /* 3989 */   // No operand predicates
     /* 3989 */   // MIs[0] bv
     /* 3989 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 3997 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 4000 */   // MIs[1] unused
     /* 4000 */   // No operand predicates
     /* 4000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4002 */   // Combiner Rule #56: buildvector_of_truncate
     /* 4002 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4005 */ // Label 250: @4005
     /* 4005 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4026), // Rule ID 46 //
     /* 4010 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 4013 */   // MIs[0] root
     /* 4013 */   // No operand predicates
     /* 4013 */   // MIs[0] ext
     /* 4013 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4021 */   // MIs[1] src
     /* 4021 */   // No operand predicates
     /* 4021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4023 */   // Combiner Rule #44: truncate_of_sext
     /* 4023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4026 */ // Label 251: @4026
     /* 4026 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4047), // Rule ID 45 //
     /* 4031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 4034 */   // MIs[0] root
     /* 4034 */   // No operand predicates
     /* 4034 */   // MIs[0] ext
     /* 4034 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4042 */   // MIs[1] src
     /* 4042 */   // No operand predicates
     /* 4042 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4044 */   // Combiner Rule #43: truncate_of_zext
     /* 4044 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4047 */ // Label 252: @4047
     /* 4047 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4068), // Rule ID 86 //
     /* 4052 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 4055 */   // MIs[0] dst
     /* 4055 */   // No operand predicates
     /* 4055 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 4055 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4065 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 4065 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4068 */ // Label 253: @4068
     /* 4068 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4089), // Rule ID 65 //
     /* 4073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 4076 */   // MIs[0] root
     /* 4076 */   // No operand predicates
     /* 4076 */   // MIs[0] int
     /* 4076 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4084 */   // MIs[1] imm
     /* 4084 */   // No operand predicates
     /* 4084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4086 */   // Combiner Rule #63: integer_of_truncate
     /* 4086 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4089 */ // Label 254: @4089
     /* 4089 */ GIM_Reject,
     /* 4090 */ // Label 28: @4090
     /* 4090 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4101), // Rule ID 359 //
     /* 4095 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4098 */   // MIs[0] dst
     /* 4098 */   // No operand predicates
     /* 4098 */   // MIs[0] src
     /* 4098 */   // No operand predicates
     /* 4098 */   // Combiner Rule #212: fconstant_to_constant
     /* 4098 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4101 */ // Label 255: @4101
     /* 4101 */ GIM_Reject,
     /* 4102 */ // Label 29: @4102
     /* 4102 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4113), // Rule ID 254 //
     /* 4107 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 4110 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 4110 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 4113 */ // Label 256: @4113
     /* 4113 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4134), // Rule ID 51 //
     /* 4118 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 4121 */   // MIs[0] root
     /* 4121 */   // No operand predicates
     /* 4121 */   // MIs[0] second
     /* 4121 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4129 */   // MIs[1] src
     /* 4129 */   // No operand predicates
     /* 4129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4131 */   // Combiner Rule #49: sext_of_anyext
     /* 4131 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4134 */ // Label 257: @4134
     /* 4134 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4155), // Rule ID 50 //
     /* 4139 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 4142 */   // MIs[0] root
     /* 4142 */   // No operand predicates
     /* 4142 */   // MIs[0] second
     /* 4142 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4150 */   // MIs[1] src
     /* 4150 */   // No operand predicates
     /* 4150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4152 */   // Combiner Rule #48: sext_of_sext
     /* 4152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4155 */ // Label 258: @4155
     /* 4155 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4176), // Rule ID 339 //
     /* 4160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 4163 */   // MIs[0] root
     /* 4163 */   // No operand predicates
     /* 4163 */   // MIs[0] src
     /* 4163 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4171 */   // MIs[1] x
     /* 4171 */   // No operand predicates
     /* 4171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4173 */   // Combiner Rule #194: sext_trunc
     /* 4173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 4176 */ // Label 259: @4176
     /* 4176 */ GIM_Reject,
     /* 4177 */ // Label 30: @4177
     /* 4177 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4188), // Rule ID 158 //
     /* 4182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4185 */   // Combiner Rule #116: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 4185 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4188 */ // Label 260: @4188
     /* 4188 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4199), // Rule ID 166 //
     /* 4193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 4196 */   // Combiner Rule #124: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4196 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 4199 */ // Label 261: @4199
     /* 4199 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4210), // Rule ID 223 //
     /* 4204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 4207 */   // Combiner Rule #160: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4207 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4210 */ // Label 262: @4210
     /* 4210 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4221), // Rule ID 170 //
     /* 4215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 4218 */   // MIs[0] dst
     /* 4218 */   // No operand predicates
     /* 4218 */   // MIs[0] src
     /* 4218 */   // No operand predicates
     /* 4218 */   // MIs[0] imm
     /* 4218 */   // No operand predicates
     /* 4218 */   // Combiner Rule #128: sext_inreg_to_zext_inreg
     /* 4218 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4221 */ // Label 263: @4221
     /* 4221 */ GIM_Reject,
     /* 4222 */ // Label 31: @4222
     /* 4222 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4233), // Rule ID 169 //
     /* 4227 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 4230 */   // Combiner Rule #127: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4230 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 4233 */ // Label 264: @4233
     /* 4233 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4244), // Rule ID 253 //
     /* 4238 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 4241 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4241 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 4244 */ // Label 265: @4244
     /* 4244 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4265), // Rule ID 55 //
     /* 4249 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4252 */   // MIs[0] root
     /* 4252 */   // No operand predicates
     /* 4252 */   // MIs[0] select
     /* 4252 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4260 */   // MIs[1] cond
     /* 4260 */   // No operand predicates
     /* 4260 */   // MIs[1] true
     /* 4260 */   // No operand predicates
     /* 4260 */   // MIs[1] false
     /* 4260 */   // No operand predicates
     /* 4260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4262 */   // Combiner Rule #53: select_of_zext
     /* 4262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4265 */ // Label 266: @4265
     /* 4265 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4286), // Rule ID 49 //
     /* 4270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4273 */   // MIs[0] root
     /* 4273 */   // No operand predicates
     /* 4273 */   // MIs[0] second
     /* 4273 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4281 */   // MIs[1] src
     /* 4281 */   // No operand predicates
     /* 4281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4283 */   // Combiner Rule #47: zext_of_anyext
     /* 4283 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4286 */ // Label 267: @4286
     /* 4286 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4313), // Rule ID 340 //
     /* 4291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 4294 */   // MIs[0] root
     /* 4294 */   // No operand predicates
     /* 4294 */   // MIs[0] src
     /* 4294 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4302 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4308 */   // MIs[1] x
     /* 4308 */   // No operand predicates
     /* 4308 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4310 */   // Combiner Rule #195: zext_trunc
     /* 4310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4313 */ // Label 268: @4313
     /* 4313 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4334), // Rule ID 48 //
     /* 4318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4321 */   // MIs[0] root
     /* 4321 */   // No operand predicates
     /* 4321 */   // MIs[0] second
     /* 4321 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4325 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4329 */   // MIs[1] src
     /* 4329 */   // No operand predicates
     /* 4329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4331 */   // Combiner Rule #46: zext_of_zext
     /* 4331 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4334 */ // Label 269: @4334
     /* 4334 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4351), // Rule ID 341 //
     /* 4339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 4342 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4348 */   // MIs[0] root
     /* 4348 */   // No operand predicates
     /* 4348 */   // MIs[0] x
     /* 4348 */   // No operand predicates
     /* 4348 */   // Combiner Rule #196: nneg_zext
     /* 4348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4351 */ // Label 270: @4351
     /* 4351 */ GIM_Reject,
     /* 4352 */ // Label 32: @4352
     /* 4352 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4363), // Rule ID 79 //
     /* 4357 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 4360 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4360 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 4363 */ // Label 271: @4363
     /* 4363 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4374), // Rule ID 82 //
     /* 4368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4371 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4374 */ // Label 272: @4374
     /* 4374 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4385), // Rule ID 115 //
     /* 4379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4382 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4382 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4385 */ // Label 273: @4385
     /* 4385 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4396), // Rule ID 198 //
     /* 4390 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 4393 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4393 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4396 */ // Label 274: @4396
     /* 4396 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4407), // Rule ID 203 //
     /* 4401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4404 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4407 */ // Label 275: @4407
     /* 4407 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4418), // Rule ID 222 //
     /* 4412 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 4415 */   // Combiner Rule #159: commute_shift; wip_match_opcode 'G_SHL'
     /* 4415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4418 */ // Label 276: @4418
     /* 4418 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4429), // Rule ID 236 //
     /* 4423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4426 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4426 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4429 */ // Label 277: @4429
     /* 4429 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4440), // Rule ID 289 //
     /* 4434 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 4437 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4437 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4440 */ // Label 278: @4440
     /* 4440 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4475), // Rule ID 41 //
     /* 4445 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4448 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4454 */   // MIs[0] root
     /* 4454 */   // No operand predicates
     /* 4454 */   // MIs[0] left
     /* 4454 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4462 */   // MIs[1] imm
     /* 4462 */   // No operand predicates
     /* 4462 */   // MIs[0] x
     /* 4462 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4466 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4470 */   // MIs[2] imm1
     /* 4470 */   // No operand predicates
     /* 4470 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4472 */   // Combiner Rule #39: shl_of_vscale
     /* 4472 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4475 */ // Label 279: @4475
     /* 4475 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4498), // Rule ID 107 //
     /* 4480 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4483 */   // MIs[0] dst
     /* 4483 */   // No operand predicates
     /* 4483 */   // MIs[0] lhs
     /* 4483 */   // No operand predicates
     /* 4483 */   // MIs[0] Operand 2
     /* 4483 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4487 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4492 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4492 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4497 */   GIR_EraseRootFromParent_Done,
     /* 4498 */ // Label 280: @4498
     /* 4498 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4509), // Rule ID 144 //
     /* 4503 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4506 */   // MIs[0] root
     /* 4506 */   // No operand predicates
     /* 4506 */   // MIs[0] mi.shifted
     /* 4506 */   // No operand predicates
     /* 4506 */   // MIs[0] mi.amt
     /* 4506 */   // No operand predicates
     /* 4506 */   // Combiner Rule #104: shifts_too_big @ [mi[0]]
     /* 4506 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4509 */ // Label 281: @4509
     /* 4509 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4520), // Rule ID 159 //
     /* 4514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 4517 */   // MIs[0] dst
     /* 4517 */   // No operand predicates
     /* 4517 */   // MIs[0] src0
     /* 4517 */   // No operand predicates
     /* 4517 */   // MIs[0] src1
     /* 4517 */   // No operand predicates
     /* 4517 */   // Combiner Rule #117: reduce_shl_of_extend
     /* 4517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4520 */ // Label 282: @4520
     /* 4520 */ GIM_Reject,
     /* 4521 */ // Label 33: @4521
     /* 4521 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4532), // Rule ID 84 //
     /* 4526 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4529 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4529 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4532 */ // Label 283: @4532
     /* 4532 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4543), // Rule ID 116 //
     /* 4537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4540 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4540 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4543 */ // Label 284: @4543
     /* 4543 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4554), // Rule ID 200 //
     /* 4548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 4551 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4551 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4554 */ // Label 285: @4554
     /* 4554 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4565), // Rule ID 205 //
     /* 4559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4562 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4565 */ // Label 286: @4565
     /* 4565 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4576), // Rule ID 226 //
     /* 4570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4573 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4576 */ // Label 287: @4576
     /* 4576 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4587), // Rule ID 228 //
     /* 4581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4584 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4587 */ // Label 288: @4587
     /* 4587 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4598), // Rule ID 233 //
     /* 4592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4595 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4595 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4598 */ // Label 289: @4598
     /* 4598 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4609), // Rule ID 287 //
     /* 4603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 4606 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4606 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4609 */ // Label 290: @4609
     /* 4609 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4632), // Rule ID 109 //
     /* 4614 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4617 */   // MIs[0] dst
     /* 4617 */   // No operand predicates
     /* 4617 */   // MIs[0] lhs
     /* 4617 */   // No operand predicates
     /* 4617 */   // MIs[0] Operand 2
     /* 4617 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4621 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4626 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4626 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4631 */   GIR_EraseRootFromParent_Done,
     /* 4632 */ // Label 291: @4632
     /* 4632 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4643), // Rule ID 146 //
     /* 4637 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4640 */   // MIs[0] root
     /* 4640 */   // No operand predicates
     /* 4640 */   // MIs[0] mi.shifted
     /* 4640 */   // No operand predicates
     /* 4640 */   // MIs[0] mi.amt
     /* 4640 */   // No operand predicates
     /* 4640 */   // Combiner Rule #104: shifts_too_big @ [mi[2]]
     /* 4640 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4643 */ // Label 292: @4643
     /* 4643 */ GIM_Reject,
     /* 4644 */ // Label 34: @4644
     /* 4644 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4655), // Rule ID 83 //
     /* 4649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4652 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4655 */ // Label 293: @4655
     /* 4655 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4666), // Rule ID 117 //
     /* 4660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4663 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4663 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4666 */ // Label 294: @4666
     /* 4666 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4677), // Rule ID 157 //
     /* 4671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4674 */   // Combiner Rule #115: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4677 */ // Label 295: @4677
     /* 4677 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4688), // Rule ID 199 //
     /* 4682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 4685 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4685 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4688 */ // Label 296: @4688
     /* 4688 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4699), // Rule ID 204 //
     /* 4693 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4696 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4696 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4699 */ // Label 297: @4699
     /* 4699 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4710), // Rule ID 225 //
     /* 4704 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4707 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4707 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4710 */ // Label 298: @4710
     /* 4710 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4721), // Rule ID 227 //
     /* 4715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4718 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4718 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4721 */ // Label 299: @4721
     /* 4721 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4732), // Rule ID 232 //
     /* 4726 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4729 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4729 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4732 */ // Label 300: @4732
     /* 4732 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4743), // Rule ID 288 //
     /* 4737 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 4740 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4740 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4743 */ // Label 301: @4743
     /* 4743 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4766), // Rule ID 108 //
     /* 4748 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4751 */   // MIs[0] dst
     /* 4751 */   // No operand predicates
     /* 4751 */   // MIs[0] lhs
     /* 4751 */   // No operand predicates
     /* 4751 */   // MIs[0] Operand 2
     /* 4751 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4755 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4760 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4760 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4765 */   GIR_EraseRootFromParent_Done,
     /* 4766 */ // Label 302: @4766
     /* 4766 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4777), // Rule ID 145 //
     /* 4771 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4774 */   // MIs[0] root
     /* 4774 */   // No operand predicates
     /* 4774 */   // MIs[0] mi.shifted
     /* 4774 */   // No operand predicates
     /* 4774 */   // MIs[0] mi.amt
     /* 4774 */   // No operand predicates
     /* 4774 */   // Combiner Rule #104: shifts_too_big @ [mi[1]]
     /* 4774 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4777 */ // Label 303: @4777
     /* 4777 */ GIM_Reject,
     /* 4778 */ // Label 35: @4778
     /* 4778 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4789), // Rule ID 214 //
     /* 4783 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 4786 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4786 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4789 */ // Label 304: @4789
     /* 4789 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4800), // Rule ID 218 //
     /* 4794 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4797 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4797 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4800 */ // Label 305: @4800
     /* 4800 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4820), // Rule ID 217 //
     /* 4805 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4808 */   // MIs[0] x
     /* 4808 */   // No operand predicates
     /* 4808 */   // MIs[0] y
     /* 4808 */   // No operand predicates
     /* 4808 */   // MIs[0] z
     /* 4808 */   // No operand predicates
     /* 4808 */   // MIs[0] Operand 3
     /* 4808 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4812 */   // Combiner Rule #155: funnel_shift_left_zero
     /* 4812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4815 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4817 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4819 */   GIR_EraseRootFromParent_Done,
     /* 4820 */ // Label 306: @4820
     /* 4820 */ GIM_Reject,
     /* 4821 */ // Label 36: @4821
     /* 4821 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4832), // Rule ID 215 //
     /* 4826 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 4829 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4829 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4832 */ // Label 307: @4832
     /* 4832 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4843), // Rule ID 219 //
     /* 4837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4840 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4840 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4843 */ // Label 308: @4843
     /* 4843 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4863), // Rule ID 216 //
     /* 4848 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4851 */   // MIs[0] x
     /* 4851 */   // No operand predicates
     /* 4851 */   // MIs[0] y
     /* 4851 */   // No operand predicates
     /* 4851 */   // MIs[0] z
     /* 4851 */   // No operand predicates
     /* 4851 */   // MIs[0] Operand 3
     /* 4851 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4855 */   // Combiner Rule #154: funnel_shift_right_zero
     /* 4855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4858 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4860 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4862 */   GIR_EraseRootFromParent_Done,
     /* 4863 */ // Label 309: @4863
     /* 4863 */ GIM_Reject,
     /* 4864 */ // Label 37: @4864
     /* 4864 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4887), // Rule ID 112 //
     /* 4869 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4872 */   // MIs[0] dst
     /* 4872 */   // No operand predicates
     /* 4872 */   // MIs[0] lhs
     /* 4872 */   // No operand predicates
     /* 4872 */   // MIs[0] Operand 2
     /* 4872 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4876 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4881 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4881 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4886 */   GIR_EraseRootFromParent_Done,
     /* 4887 */ // Label 310: @4887
     /* 4887 */ GIM_Reject,
     /* 4888 */ // Label 38: @4888
     /* 4888 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4911), // Rule ID 111 //
     /* 4893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4896 */   // MIs[0] dst
     /* 4896 */   // No operand predicates
     /* 4896 */   // MIs[0] lhs
     /* 4896 */   // No operand predicates
     /* 4896 */   // MIs[0] Operand 2
     /* 4896 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4900 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4905 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4905 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4910 */   GIR_EraseRootFromParent_Done,
     /* 4911 */ // Label 311: @4911
     /* 4911 */ GIM_Reject,
     /* 4912 */ // Label 39: @4912
     /* 4912 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4923), // Rule ID 152 //
     /* 4917 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4920 */   // Combiner Rule #110: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4923 */ // Label 312: @4923
     /* 4923 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4934), // Rule ID 153 //
     /* 4928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4931 */   // Combiner Rule #111: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4931 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4934 */ // Label 313: @4934
     /* 4934 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4945), // Rule ID 156 //
     /* 4939 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 4942 */   // Combiner Rule #114: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4942 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4945 */ // Label 314: @4945
     /* 4945 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4956), // Rule ID 150 //
     /* 4950 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 4953 */   // MIs[0] root
     /* 4953 */   // No operand predicates
     /* 4953 */   // MIs[0] pred
     /* 4953 */   // No operand predicates
     /* 4953 */   // MIs[0] lhs
     /* 4953 */   // No operand predicates
     /* 4953 */   // MIs[0] rhs
     /* 4953 */   // No operand predicates
     /* 4953 */   // Combiner Rule #108: canonicalize_icmp
     /* 4953 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 4956 */ // Label 315: @4956
     /* 4956 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4967), // Rule ID 360 //
     /* 4961 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4964 */   // MIs[0] dst
     /* 4964 */   // No operand predicates
     /* 4964 */   // MIs[0] tst
     /* 4964 */   // No operand predicates
     /* 4964 */   // MIs[0] src1
     /* 4964 */   // No operand predicates
     /* 4964 */   // MIs[0] src2
     /* 4964 */   // No operand predicates
     /* 4964 */   // Combiner Rule #213: icmp_redundant_trunc
     /* 4964 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 4967 */ // Label 316: @4967
     /* 4967 */ GIM_Reject,
     /* 4968 */ // Label 40: @4968
     /* 4968 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(4979), // Rule ID 151 //
     /* 4973 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 4976 */   // MIs[0] root
     /* 4976 */   // No operand predicates
     /* 4976 */   // MIs[0] pred
     /* 4976 */   // No operand predicates
     /* 4976 */   // MIs[0] lhs
     /* 4976 */   // No operand predicates
     /* 4976 */   // MIs[0] rhs
     /* 4976 */   // No operand predicates
     /* 4976 */   // Combiner Rule #109: canonicalize_fcmp
     /* 4976 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 4979 */ // Label 317: @4979
     /* 4979 */ GIM_Reject,
     /* 4980 */ // Label 41: @4980
     /* 4980 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(4991), // Rule ID 102 //
     /* 4985 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 4988 */   // Combiner Rule #82: select_same_val; wip_match_opcode 'G_SELECT'
     /* 4988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 4991 */ // Label 318: @4991
     /* 4991 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(5002), // Rule ID 162 //
     /* 4996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 4999 */   // Combiner Rule #120: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 4999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 5002 */ // Label 319: @5002
     /* 5002 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(5013), // Rule ID 164 //
     /* 5007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 5010 */   // Combiner Rule #122: match_selects; wip_match_opcode 'G_SELECT'
     /* 5010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 5013 */ // Label 320: @5013
     /* 5013 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(5024), // Rule ID 304 //
     /* 5018 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5021 */   // Combiner Rule #186: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 5021 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 5024 */ // Label 321: @5024
     /* 5024 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(5045), // Rule ID 163 //
     /* 5029 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 5032 */   // MIs[0] root
     /* 5032 */   // No operand predicates
     /* 5032 */   // MIs[0] tst
     /* 5032 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 5040 */   // MIs[1] tst1
     /* 5040 */   // No operand predicates
     /* 5040 */   // MIs[1] a
     /* 5040 */   // No operand predicates
     /* 5040 */   // MIs[1] b
     /* 5040 */   // No operand predicates
     /* 5040 */   // MIs[0] x
     /* 5040 */   // No operand predicates
     /* 5040 */   // MIs[0] y
     /* 5040 */   // No operand predicates
     /* 5040 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5042 */   // Combiner Rule #121: select_to_iminmax
     /* 5042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 5045 */ // Label 322: @5045
     /* 5045 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(5074), // Rule ID 161 //
     /* 5050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 5053 */   // MIs[0] dst
     /* 5053 */   // No operand predicates
     /* 5053 */   // MIs[0] undef
     /* 5053 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5061 */   // MIs[0] x
     /* 5061 */   // No operand predicates
     /* 5061 */   // MIs[0] y
     /* 5061 */   // No operand predicates
     /* 5061 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5068 */   // Combiner Rule #119: select_undef_cmp
     /* 5068 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5073 */   GIR_EraseRootFromParent_Done,
     /* 5074 */ // Label 323: @5074
     /* 5074 */ GIM_Reject,
     /* 5075 */ // Label 42: @5075
     /* 5075 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(5086), // Rule ID 315 //
     /* 5080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5083 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 5083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5086 */ // Label 324: @5086
     /* 5086 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(5097), // Rule ID 356 //
     /* 5091 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 5094 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_UADDO'
     /* 5094 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 5097 */ // Label 325: @5097
     /* 5097 */ GIM_Reject,
     /* 5098 */ // Label 43: @5098
     /* 5098 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(5109), // Rule ID 187 //
     /* 5103 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5106 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 5106 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5109 */ // Label 326: @5109
     /* 5109 */ GIM_Reject,
     /* 5110 */ // Label 44: @5110
     /* 5110 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5121), // Rule ID 358 //
     /* 5115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 5118 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 5118 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5121 */ // Label 327: @5121
     /* 5121 */ GIM_Reject,
     /* 5122 */ // Label 45: @5122
     /* 5122 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5133), // Rule ID 189 //
     /* 5127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5130 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 5130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5133 */ // Label 328: @5133
     /* 5133 */ GIM_Reject,
     /* 5134 */ // Label 46: @5134
     /* 5134 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5145), // Rule ID 316 //
     /* 5139 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5142 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 5142 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5145 */ // Label 329: @5145
     /* 5145 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5156), // Rule ID 355 //
     /* 5150 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 5153 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_SADDO'
     /* 5153 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 5156 */ // Label 330: @5156
     /* 5156 */ GIM_Reject,
     /* 5157 */ // Label 47: @5157
     /* 5157 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5168), // Rule ID 188 //
     /* 5162 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5165 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 5165 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5168 */ // Label 331: @5168
     /* 5168 */ GIM_Reject,
     /* 5169 */ // Label 48: @5169
     /* 5169 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5180), // Rule ID 357 //
     /* 5174 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 5177 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 5177 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5180 */ // Label 332: @5180
     /* 5180 */ GIM_Reject,
     /* 5181 */ // Label 49: @5181
     /* 5181 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5192), // Rule ID 190 //
     /* 5186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5189 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 5189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5192 */ // Label 333: @5192
     /* 5192 */ GIM_Reject,
     /* 5193 */ // Label 50: @5193
     /* 5193 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5204), // Rule ID 183 //
     /* 5198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 5201 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 5201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 5204 */ // Label 334: @5204
     /* 5204 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5215), // Rule ID 185 //
     /* 5209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 5212 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5215 */ // Label 335: @5215
     /* 5215 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5226), // Rule ID 317 //
     /* 5220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5223 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5226 */ // Label 336: @5226
     /* 5226 */ GIM_Reject,
     /* 5227 */ // Label 51: @5227
     /* 5227 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5238), // Rule ID 184 //
     /* 5232 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 5235 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5235 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 5238 */ // Label 337: @5238
     /* 5238 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5249), // Rule ID 186 //
     /* 5243 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 5246 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5246 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5249 */ // Label 338: @5249
     /* 5249 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5260), // Rule ID 318 //
     /* 5254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5257 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5257 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5260 */ // Label 339: @5260
     /* 5260 */ GIM_Reject,
     /* 5261 */ // Label 52: @5261
     /* 5261 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5272), // Rule ID 261 //
     /* 5266 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 5269 */   // Combiner Rule #173: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5269 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 5272 */ // Label 340: @5272
     /* 5272 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5283), // Rule ID 319 //
     /* 5277 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5280 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5280 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5283 */ // Label 341: @5283
     /* 5283 */ GIM_Reject,
     /* 5284 */ // Label 53: @5284
     /* 5284 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5295), // Rule ID 320 //
     /* 5289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5292 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5295 */ // Label 342: @5295
     /* 5295 */ GIM_Reject,
     /* 5296 */ // Label 54: @5296
     /* 5296 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5307), // Rule ID 321 //
     /* 5301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5304 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5304 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5307 */ // Label 343: @5307
     /* 5307 */ GIM_Reject,
     /* 5308 */ // Label 55: @5308
     /* 5308 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5319), // Rule ID 322 //
     /* 5313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5316 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5316 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5319 */ // Label 344: @5319
     /* 5319 */ GIM_Reject,
     /* 5320 */ // Label 56: @5320
     /* 5320 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5331), // Rule ID 202 //
     /* 5325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 5328 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5331 */ // Label 345: @5331
     /* 5331 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5342), // Rule ID 206 //
     /* 5336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5339 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5342 */ // Label 346: @5342
     /* 5342 */ GIM_Reject,
     /* 5343 */ // Label 57: @5343
     /* 5343 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5354), // Rule ID 201 //
     /* 5348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 5351 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5354 */ // Label 347: @5354
     /* 5354 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5365), // Rule ID 207 //
     /* 5359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5362 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5362 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5365 */ // Label 348: @5365
     /* 5365 */ GIM_Reject,
     /* 5366 */ // Label 58: @5366
     /* 5366 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5377), // Rule ID 323 //
     /* 5371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5374 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5377 */ // Label 349: @5377
     /* 5377 */ GIM_Reject,
     /* 5378 */ // Label 59: @5378
     /* 5378 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5389), // Rule ID 324 //
     /* 5383 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5386 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5389 */ // Label 350: @5389
     /* 5389 */ GIM_Reject,
     /* 5390 */ // Label 60: @5390
     /* 5390 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5401), // Rule ID 325 //
     /* 5395 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5398 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5398 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5401 */ // Label 351: @5401
     /* 5401 */ GIM_Reject,
     /* 5402 */ // Label 61: @5402
     /* 5402 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5413), // Rule ID 326 //
     /* 5407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5410 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5413 */ // Label 352: @5413
     /* 5413 */ GIM_Reject,
     /* 5414 */ // Label 62: @5414
     /* 5414 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5425), // Rule ID 247 //
     /* 5419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5422 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5422 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5425 */ // Label 353: @5425
     /* 5425 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5436), // Rule ID 262 //
     /* 5430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5433 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5433 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5436 */ // Label 354: @5436
     /* 5436 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5447), // Rule ID 269 //
     /* 5441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5444 */   // Combiner Rule #176: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5444 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 5447 */ // Label 355: @5447
     /* 5447 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5458), // Rule ID 270 //
     /* 5452 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 5455 */   // Combiner Rule #177: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5458 */ // Label 356: @5458
     /* 5458 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5469), // Rule ID 271 //
     /* 5463 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5466 */   // Combiner Rule #178: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5466 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5469 */ // Label 357: @5469
     /* 5469 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5480), // Rule ID 272 //
     /* 5474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5477 */   // Combiner Rule #179: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5480 */ // Label 358: @5480
     /* 5480 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5491), // Rule ID 295 //
     /* 5485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5488 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5491 */ // Label 359: @5491
     /* 5491 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5502), // Rule ID 327 //
     /* 5496 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5499 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5502 */ // Label 360: @5502
     /* 5502 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5525), // Rule ID 137 //
     /* 5507 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5510 */   // MIs[0] dst
     /* 5510 */   // No operand predicates
     /* 5510 */   // MIs[0] x
     /* 5510 */   // No operand predicates
     /* 5510 */   // MIs[0] y
     /* 5510 */   // No operand predicates
     /* 5510 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5514 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5519 */   // Combiner Rule #99: right_identity_neg_zero_fp
     /* 5519 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5524 */   GIR_EraseRootFromParent_Done,
     /* 5525 */ // Label 361: @5525
     /* 5525 */ GIM_Reject,
     /* 5526 */ // Label 63: @5526
     /* 5526 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5537), // Rule ID 248 //
     /* 5531 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5534 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5534 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5537 */ // Label 362: @5537
     /* 5537 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5548), // Rule ID 263 //
     /* 5542 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5545 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5548 */ // Label 363: @5548
     /* 5548 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5559), // Rule ID 273 //
     /* 5553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5556 */   // Combiner Rule #180: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5559 */ // Label 364: @5559
     /* 5559 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5570), // Rule ID 274 //
     /* 5564 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5567 */   // Combiner Rule #181: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5567 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5570 */ // Label 365: @5570
     /* 5570 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5581), // Rule ID 275 //
     /* 5575 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5578 */   // Combiner Rule #182: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5578 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5581 */ // Label 366: @5581
     /* 5581 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5592), // Rule ID 276 //
     /* 5586 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5589 */   // Combiner Rule #183: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5589 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5592 */ // Label 367: @5592
     /* 5592 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5603), // Rule ID 296 //
     /* 5597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5600 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5600 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5603 */ // Label 368: @5603
     /* 5603 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5614), // Rule ID 305 //
     /* 5608 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 5611 */   // Combiner Rule #187: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5611 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5614 */ // Label 369: @5614
     /* 5614 */ GIM_Reject,
     /* 5615 */ // Label 64: @5615
     /* 5615 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5626), // Rule ID 249 //
     /* 5620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5623 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5626 */ // Label 370: @5626
     /* 5626 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5637), // Rule ID 264 //
     /* 5631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5634 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5634 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5637 */ // Label 371: @5637
     /* 5637 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5648), // Rule ID 294 //
     /* 5642 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5645 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5648 */ // Label 372: @5648
     /* 5648 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5659), // Rule ID 328 //
     /* 5653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5656 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5659 */ // Label 373: @5659
     /* 5659 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5682), // Rule ID 128 //
     /* 5664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 5667 */   // MIs[0] dst
     /* 5667 */   // No operand predicates
     /* 5667 */   // MIs[0] x
     /* 5667 */   // No operand predicates
     /* 5667 */   // MIs[0] y
     /* 5667 */   // No operand predicates
     /* 5667 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5671 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5676 */   // Combiner Rule #92: right_identity_one_fp
     /* 5676 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5681 */   GIR_EraseRootFromParent_Done,
     /* 5682 */ // Label 374: @5682
     /* 5682 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5702), // Rule ID 138 //
     /* 5687 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5690 */   // MIs[0] dst
     /* 5690 */   // No operand predicates
     /* 5690 */   // MIs[0] x
     /* 5690 */   // No operand predicates
     /* 5690 */   // MIs[0] y
     /* 5690 */   // No operand predicates
     /* 5690 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5694 */   // Combiner Rule #100: right_identity_neg_one_fp
     /* 5694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5697 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5699 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5701 */   GIR_EraseRootFromParent_Done,
     /* 5702 */ // Label 375: @5702
     /* 5702 */ GIM_Reject,
     /* 5703 */ // Label 65: @5703
     /* 5703 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5714), // Rule ID 252 //
     /* 5708 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5711 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5711 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5714 */ // Label 376: @5714
     /* 5714 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5725), // Rule ID 267 //
     /* 5719 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5722 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5722 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5725 */ // Label 377: @5725
     /* 5725 */ GIM_Reject,
     /* 5726 */ // Label 66: @5726
     /* 5726 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5737), // Rule ID 251 //
     /* 5731 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5734 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5734 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5737 */ // Label 378: @5737
     /* 5737 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5748), // Rule ID 266 //
     /* 5742 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5745 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5745 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5748 */ // Label 379: @5748
     /* 5748 */ GIM_Reject,
     /* 5749 */ // Label 67: @5749
     /* 5749 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5760), // Rule ID 250 //
     /* 5754 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5757 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5760 */ // Label 380: @5760
     /* 5760 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5771), // Rule ID 265 //
     /* 5765 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5768 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5768 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5771 */ // Label 381: @5771
     /* 5771 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5782), // Rule ID 297 //
     /* 5776 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5779 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5782 */ // Label 382: @5782
     /* 5782 */ GIM_Reject,
     /* 5783 */ // Label 68: @5783
     /* 5783 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5794), // Rule ID 298 //
     /* 5788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5791 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5791 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5794 */ // Label 383: @5794
     /* 5794 */ GIM_Reject,
     /* 5795 */ // Label 69: @5795
     /* 5795 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5816), // Rule ID 195 //
     /* 5800 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5803 */   // MIs[0] dst
     /* 5803 */   // No operand predicates
     /* 5803 */   // MIs[0] float
     /* 5803 */   // No operand predicates
     /* 5803 */   // MIs[0] int
     /* 5803 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5811 */   // MIs[1] imm
     /* 5811 */   // No operand predicates
     /* 5811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5813 */   // Combiner Rule #145: expand_const_fpowi
     /* 5813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5816 */ // Label 384: @5816
     /* 5816 */ GIM_Reject,
     /* 5817 */ // Label 70: @5817
     /* 5817 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5838), // Rule ID 177 //
     /* 5822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 5825 */   // MIs[0] dst
     /* 5825 */   // No operand predicates
     /* 5825 */   // MIs[0] src0
     /* 5825 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5833 */   // MIs[1] cst
     /* 5833 */   // No operand predicates
     /* 5833 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5835 */   // Combiner Rule #135: constant_fold_flog2
     /* 5835 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5838 */ // Label 385: @5838
     /* 5838 */ GIM_Reject,
     /* 5839 */ // Label 71: @5839
     /* 5839 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5860), // Rule ID 174 //
     /* 5844 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 5847 */   // MIs[0] dst
     /* 5847 */   // No operand predicates
     /* 5847 */   // MIs[0] src0
     /* 5847 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5855 */   // MIs[1] cst
     /* 5855 */   // No operand predicates
     /* 5855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5857 */   // Combiner Rule #132: constant_fold_fneg
     /* 5857 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5860 */ // Label 386: @5860
     /* 5860 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5889), // Rule ID 126 //
     /* 5865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 5868 */   // MIs[0] dst
     /* 5868 */   // No operand predicates
     /* 5868 */   // MIs[0] t
     /* 5868 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5876 */   // MIs[1] src
     /* 5876 */   // No operand predicates
     /* 5876 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5883 */   // Combiner Rule #90: fneg_fneg_fold
     /* 5883 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5888 */   GIR_EraseRootFromParent_Done,
     /* 5889 */ // Label 387: @5889
     /* 5889 */ GIM_Reject,
     /* 5890 */ // Label 72: @5890
     /* 5890 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5911), // Rule ID 178 //
     /* 5895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 5898 */   // MIs[0] dst
     /* 5898 */   // No operand predicates
     /* 5898 */   // MIs[0] src0
     /* 5898 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5906 */   // MIs[1] cst
     /* 5906 */   // No operand predicates
     /* 5906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5908 */   // Combiner Rule #136: constant_fold_fptrunc
     /* 5908 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5911 */ // Label 388: @5911
     /* 5911 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5932), // Rule ID 136 //
     /* 5916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 5919 */   // MIs[0] dst
     /* 5919 */   // No operand predicates
     /* 5919 */   // MIs[0] src1
     /* 5919 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5927 */   // MIs[1] src0
     /* 5927 */   // No operand predicates
     /* 5927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5929 */   // Combiner Rule #98: fptrunc_fpext_fold
     /* 5929 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 5932 */ // Label 389: @5932
     /* 5932 */ GIM_Reject,
     /* 5933 */ // Label 73: @5933
     /* 5933 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5954), // Rule ID 91 //
     /* 5938 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5941 */   // MIs[0] dst
     /* 5941 */   // No operand predicates
     /* 5941 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5941 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5945 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5951 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5951 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5954 */ // Label 390: @5954
     /* 5954 */ GIM_Reject,
     /* 5955 */ // Label 74: @5955
     /* 5955 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5976), // Rule ID 92 //
     /* 5960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5963 */   // MIs[0] dst
     /* 5963 */   // No operand predicates
     /* 5963 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5963 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5967 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5973 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 5973 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5976 */ // Label 391: @5976
     /* 5976 */ GIM_Reject,
     /* 5977 */ // Label 75: @5977
     /* 5977 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(5988), // Rule ID 75 //
     /* 5982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 5985 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 5985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 5988 */ // Label 392: @5988
     /* 5988 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(6003), // Rule ID 179 //
     /* 5993 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5996 */   // MIs[0] dst
     /* 5996 */   // No operand predicates
     /* 5996 */   // MIs[0] Operand 1
     /* 5996 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6000 */   // Combiner Rule #137: itof_const_zero_fold_si
     /* 6000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6003 */ // Label 393: @6003
     /* 6003 */ GIM_Reject,
     /* 6004 */ // Label 76: @6004
     /* 6004 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(6015), // Rule ID 74 //
     /* 6009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6012 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 6012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6015 */ // Label 394: @6015
     /* 6015 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(6030), // Rule ID 180 //
     /* 6020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 6023 */   // MIs[0] dst
     /* 6023 */   // No operand predicates
     /* 6023 */   // MIs[0] Operand 1
     /* 6023 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6027 */   // Combiner Rule #138: itof_const_zero_fold_ui
     /* 6027 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6030 */ // Label 395: @6030
     /* 6030 */ GIM_Reject,
     /* 6031 */ // Label 77: @6031
     /* 6031 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(6060), // Rule ID 19 //
     /* 6036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6039 */   // MIs[0] dst
     /* 6039 */   // No operand predicates
     /* 6039 */   // MIs[0] src
     /* 6039 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6047 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6047 */   // No operand predicates
     /* 6047 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6054 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 6054 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6059 */   GIR_EraseRootFromParent_Done,
     /* 6060 */ // Label 396: @6060
     /* 6060 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6081), // Rule ID 175 //
     /* 6065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6068 */   // MIs[0] dst
     /* 6068 */   // No operand predicates
     /* 6068 */   // MIs[0] src0
     /* 6068 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6076 */   // MIs[1] cst
     /* 6076 */   // No operand predicates
     /* 6076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6078 */   // Combiner Rule #133: constant_fold_fabs
     /* 6078 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6081 */ // Label 397: @6081
     /* 6081 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6109), // Rule ID 256 //
     /* 6086 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 6089 */   // MIs[0] dst
     /* 6089 */   // No operand predicates
     /* 6089 */   // MIs[0] tmp
     /* 6089 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6093 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 6097 */   // MIs[1] x
     /* 6097 */   // No operand predicates
     /* 6097 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6099 */   // Combiner Rule #168: fabs_fneg_fold
     /* 6099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 6104 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 6108 */   GIR_EraseRootFromParent_Done,
     /* 6109 */ // Label 398: @6109
     /* 6109 */ GIM_Reject,
     /* 6110 */ // Label 78: @6110
     /* 6110 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6139), // Rule ID 20 //
     /* 6115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6118 */   // MIs[0] dst
     /* 6118 */   // No operand predicates
     /* 6118 */   // MIs[0] src
     /* 6118 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 6126 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6126 */   // No operand predicates
     /* 6126 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6133 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 6133 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6138 */   GIR_EraseRootFromParent_Done,
     /* 6139 */ // Label 399: @6139
     /* 6139 */ GIM_Reject,
     /* 6140 */ // Label 79: @6140
     /* 6140 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6151), // Rule ID 191 //
     /* 6145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 6148 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 6148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6151 */ // Label 400: @6151
     /* 6151 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6162), // Rule ID 299 //
     /* 6156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6159 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 6159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6162 */ // Label 401: @6162
     /* 6162 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6173), // Rule ID 329 //
     /* 6167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6170 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 6170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6173 */ // Label 402: @6173
     /* 6173 */ GIM_Reject,
     /* 6174 */ // Label 80: @6174
     /* 6174 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6185), // Rule ID 192 //
     /* 6179 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 6182 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 6182 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6185 */ // Label 403: @6185
     /* 6185 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6196), // Rule ID 300 //
     /* 6190 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6193 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6193 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6196 */ // Label 404: @6196
     /* 6196 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6207), // Rule ID 330 //
     /* 6201 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6204 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6204 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6207 */ // Label 405: @6207
     /* 6207 */ GIM_Reject,
     /* 6208 */ // Label 81: @6208
     /* 6208 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6219), // Rule ID 331 //
     /* 6213 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6216 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6216 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6219 */ // Label 406: @6219
     /* 6219 */ GIM_Reject,
     /* 6220 */ // Label 82: @6220
     /* 6220 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6231), // Rule ID 332 //
     /* 6225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6228 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6228 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6231 */ // Label 407: @6231
     /* 6231 */ GIM_Reject,
     /* 6232 */ // Label 83: @6232
     /* 6232 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6243), // Rule ID 193 //
     /* 6237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 6240 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6240 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6243 */ // Label 408: @6243
     /* 6243 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6254), // Rule ID 301 //
     /* 6248 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6251 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6251 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6254 */ // Label 409: @6254
     /* 6254 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6265), // Rule ID 333 //
     /* 6259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6262 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6265 */ // Label 410: @6265
     /* 6265 */ GIM_Reject,
     /* 6266 */ // Label 84: @6266
     /* 6266 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6277), // Rule ID 194 //
     /* 6271 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 6274 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6274 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6277 */ // Label 411: @6277
     /* 6277 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6288), // Rule ID 302 //
     /* 6282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6285 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6285 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6288 */ // Label 412: @6288
     /* 6288 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6299), // Rule ID 334 //
     /* 6293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6296 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6299 */ // Label 413: @6299
     /* 6299 */ GIM_Reject,
     /* 6300 */ // Label 85: @6300
     /* 6300 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6311), // Rule ID 147 //
     /* 6305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 6308 */   // Combiner Rule #105: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6308 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 6311 */ // Label 414: @6311
     /* 6311 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6322), // Rule ID 149 //
     /* 6316 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 6319 */   // Combiner Rule #107: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6319 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 6322 */ // Label 415: @6322
     /* 6322 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6333), // Rule ID 181 //
     /* 6327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 6330 */   // Combiner Rule #139: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6333 */ // Label 416: @6333
     /* 6333 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6344), // Rule ID 197 //
     /* 6338 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 6341 */   // Combiner Rule #147: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6341 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 6344 */ // Label 417: @6344
     /* 6344 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6355), // Rule ID 230 //
     /* 6349 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6352 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6355 */ // Label 418: @6355
     /* 6355 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6366), // Rule ID 279 //
     /* 6360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6363 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6366 */ // Label 419: @6366
     /* 6366 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6389), // Rule ID 110 //
     /* 6371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 6374 */   // MIs[0] dst
     /* 6374 */   // No operand predicates
     /* 6374 */   // MIs[0] lhs
     /* 6374 */   // No operand predicates
     /* 6374 */   // MIs[0] Operand 2
     /* 6374 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6378 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6383 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6383 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6388 */   GIR_EraseRootFromParent_Done,
     /* 6389 */ // Label 420: @6389
     /* 6389 */ GIM_Reject,
     /* 6390 */ // Label 86: @6390
     /* 6390 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6401), // Rule ID 243 //
     /* 6395 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6398 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6398 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6401 */ // Label 421: @6401
     /* 6401 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6412), // Rule ID 290 //
     /* 6406 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6409 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6409 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6412 */ // Label 422: @6412
     /* 6412 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6423), // Rule ID 311 //
     /* 6417 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6420 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6420 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6423 */ // Label 423: @6423
     /* 6423 */ GIM_Reject,
     /* 6424 */ // Label 87: @6424
     /* 6424 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6435), // Rule ID 244 //
     /* 6429 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6432 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6432 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6435 */ // Label 424: @6435
     /* 6435 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6446), // Rule ID 291 //
     /* 6440 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6443 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6443 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6446 */ // Label 425: @6446
     /* 6446 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6457), // Rule ID 312 //
     /* 6451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6454 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6454 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6457 */ // Label 426: @6457
     /* 6457 */ GIM_Reject,
     /* 6458 */ // Label 88: @6458
     /* 6458 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6469), // Rule ID 245 //
     /* 6463 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6466 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6466 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6469 */ // Label 427: @6469
     /* 6469 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6480), // Rule ID 292 //
     /* 6474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6477 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6480 */ // Label 428: @6480
     /* 6480 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6491), // Rule ID 313 //
     /* 6485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6488 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6491 */ // Label 429: @6491
     /* 6491 */ GIM_Reject,
     /* 6492 */ // Label 89: @6492
     /* 6492 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6503), // Rule ID 246 //
     /* 6497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6500 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6500 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6503 */ // Label 430: @6503
     /* 6503 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6514), // Rule ID 293 //
     /* 6508 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6511 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6514 */ // Label 431: @6514
     /* 6514 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6525), // Rule ID 314 //
     /* 6519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6522 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6525 */ // Label 432: @6525
     /* 6525 */ GIM_Reject,
     /* 6526 */ // Label 90: @6526
     /* 6526 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6537), // Rule ID 85 //
     /* 6531 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 6534 */   // Combiner Rule #75: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6534 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 6537 */ // Label 433: @6537
     /* 6537 */ GIM_Reject,
     /* 6538 */ // Label 91: @6538
     /* 6538 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6549), // Rule ID 173 //
     /* 6543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 6546 */   // Combiner Rule #131: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6546 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 6549 */ // Label 434: @6549
     /* 6549 */ GIM_Reject,
     /* 6550 */ // Label 92: @6550
     /* 6550 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6561), // Rule ID 26 //
     /* 6555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6558 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6558 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6561 */ // Label 435: @6561
     /* 6561 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6572), // Rule ID 66 //
     /* 6566 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 6569 */   // Combiner Rule #64: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6569 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 6572 */ // Label 436: @6572
     /* 6572 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6583), // Rule ID 100 //
     /* 6577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6580 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6583 */ // Label 437: @6583
     /* 6583 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6622), // Rule ID 38 //
     /* 6588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6591 */   // MIs[0] root
     /* 6591 */   // No operand predicates
     /* 6591 */   // MIs[0] src
     /* 6591 */   // No operand predicates
     /* 6591 */   // MIs[0] elt
     /* 6591 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6599 */   // MIs[1] src
     /* 6599 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6604 */   // MIs[1] idx
     /* 6604 */   // No operand predicates
     /* 6604 */   // MIs[0] idx
     /* 6604 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6609 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6614 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6616 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6616 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6621 */   GIR_EraseRootFromParent_Done,
     /* 6622 */ // Label 438: @6622
     /* 6622 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6655), // Rule ID 24 //
     /* 6627 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6630 */   // MIs[0] root
     /* 6630 */   // No operand predicates
     /* 6630 */   // MIs[0] src
     /* 6630 */   // No operand predicates
     /* 6630 */   // MIs[0] elt
     /* 6630 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6638 */   // MIs[0] idx
     /* 6638 */   // No operand predicates
     /* 6638 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6642 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6647 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6649 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6649 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6654 */   GIR_EraseRootFromParent_Done,
     /* 6655 */ // Label 439: @6655
     /* 6655 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6679), // Rule ID 23 //
     /* 6660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6663 */   // MIs[0] root
     /* 6663 */   // No operand predicates
     /* 6663 */   // MIs[0] src
     /* 6663 */   // No operand predicates
     /* 6663 */   // MIs[0] elt
     /* 6663 */   // No operand predicates
     /* 6663 */   // MIs[0] idx
     /* 6663 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6673 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6676 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6678 */   GIR_EraseRootFromParent_Done,
     /* 6679 */ // Label 440: @6679
     /* 6679 */ GIM_Reject,
     /* 6680 */ // Label 93: @6680
     /* 6680 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6691), // Rule ID 25 //
     /* 6685 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6688 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6688 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6691 */ // Label 441: @6691
     /* 6691 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6702), // Rule ID 67 //
     /* 6696 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6699 */   // Combiner Rule #65: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6699 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6702 */ // Label 442: @6702
     /* 6702 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6713), // Rule ID 73 //
     /* 6707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 6710 */   // Combiner Rule #69: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6710 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 6713 */ // Label 443: @6713
     /* 6713 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6724), // Rule ID 101 //
     /* 6718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6721 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6721 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6724 */ // Label 444: @6724
     /* 6724 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6748), // Rule ID 36 //
     /* 6729 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6732 */   // MIs[0] root
     /* 6732 */   // No operand predicates
     /* 6732 */   // MIs[0] src
     /* 6732 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6740 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6743 */   // MIs[1] x
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[1] y
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[1] z
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[1] a
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[1] b
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[1] c
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[1] d
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[1] e
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[0] idx
     /* 6743 */   // No operand predicates
     /* 6743 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6745 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6745 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6748 */ // Label 445: @6748
     /* 6748 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6772), // Rule ID 35 //
     /* 6753 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6756 */   // MIs[0] root
     /* 6756 */   // No operand predicates
     /* 6756 */   // MIs[0] src
     /* 6756 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6764 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6767 */   // MIs[1] x
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] y
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] z
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] a
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] b
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] c
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[1] d
     /* 6767 */   // No operand predicates
     /* 6767 */   // MIs[0] idx
     /* 6767 */   // No operand predicates
     /* 6767 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6769 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6769 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6772 */ // Label 446: @6772
     /* 6772 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6796), // Rule ID 34 //
     /* 6777 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6780 */   // MIs[0] root
     /* 6780 */   // No operand predicates
     /* 6780 */   // MIs[0] src
     /* 6780 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6784 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6788 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6791 */   // MIs[1] x
     /* 6791 */   // No operand predicates
     /* 6791 */   // MIs[1] y
     /* 6791 */   // No operand predicates
     /* 6791 */   // MIs[1] z
     /* 6791 */   // No operand predicates
     /* 6791 */   // MIs[1] a
     /* 6791 */   // No operand predicates
     /* 6791 */   // MIs[1] b
     /* 6791 */   // No operand predicates
     /* 6791 */   // MIs[1] c
     /* 6791 */   // No operand predicates
     /* 6791 */   // MIs[0] idx
     /* 6791 */   // No operand predicates
     /* 6791 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6793 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6793 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6796 */ // Label 447: @6796
     /* 6796 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6820), // Rule ID 33 //
     /* 6801 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6804 */   // MIs[0] root
     /* 6804 */   // No operand predicates
     /* 6804 */   // MIs[0] src
     /* 6804 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6812 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6815 */   // MIs[1] x
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] y
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] z
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] a
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] b
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[0] idx
     /* 6815 */   // No operand predicates
     /* 6815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6817 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6820 */ // Label 448: @6820
     /* 6820 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6844), // Rule ID 32 //
     /* 6825 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6828 */   // MIs[0] root
     /* 6828 */   // No operand predicates
     /* 6828 */   // MIs[0] src
     /* 6828 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6836 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6839 */   // MIs[1] x
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] y
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] z
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] a
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[0] idx
     /* 6839 */   // No operand predicates
     /* 6839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6841 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6844 */ // Label 449: @6844
     /* 6844 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6868), // Rule ID 31 //
     /* 6849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6852 */   // MIs[0] root
     /* 6852 */   // No operand predicates
     /* 6852 */   // MIs[0] src
     /* 6852 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6860 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6863 */   // MIs[1] x
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[1] y
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[1] z
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[0] idx
     /* 6863 */   // No operand predicates
     /* 6863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6865 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6868 */ // Label 450: @6868
     /* 6868 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6902), // Rule ID 27 //
     /* 6873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6876 */   // MIs[0] root
     /* 6876 */   // No operand predicates
     /* 6876 */   // MIs[0] src
     /* 6876 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6884 */   // MIs[1] x
     /* 6884 */   // No operand predicates
     /* 6884 */   // MIs[1] value
     /* 6884 */   // No operand predicates
     /* 6884 */   // MIs[1] idx
     /* 6884 */   // No operand predicates
     /* 6884 */   // MIs[0] idx
     /* 6884 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6889 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6896 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6896 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6901 */   GIR_EraseRootFromParent_Done,
     /* 6902 */ // Label 451: @6902
     /* 6902 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6923), // Rule ID 28 //
     /* 6907 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6910 */   // MIs[0] root
     /* 6910 */   // No operand predicates
     /* 6910 */   // MIs[0] src
     /* 6910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6918 */   // MIs[1] x
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[1] value
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[1] idx2
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[0] idx1
     /* 6918 */   // No operand predicates
     /* 6918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6920 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6923 */ // Label 452: @6923
     /* 6923 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6952), // Rule ID 37 //
     /* 6928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6931 */   // MIs[0] root
     /* 6931 */   // No operand predicates
     /* 6931 */   // MIs[0] src
     /* 6931 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6939 */   // MIs[1] src1
     /* 6939 */   // No operand predicates
     /* 6939 */   // MIs[1] src2
     /* 6939 */   // No operand predicates
     /* 6939 */   // MIs[1] mask
     /* 6939 */   // No operand predicates
     /* 6939 */   // MIs[0] idx
     /* 6939 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6943 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6947 */   // MIs[2] imm
     /* 6947 */   // No operand predicates
     /* 6947 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6949 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6952 */ // Label 453: @6952
     /* 6952 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6976), // Rule ID 30 //
     /* 6957 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 6960 */   // MIs[0] root
     /* 6960 */   // No operand predicates
     /* 6960 */   // MIs[0] src
     /* 6960 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6968 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 6971 */   // MIs[1] x
     /* 6971 */   // No operand predicates
     /* 6971 */   // MIs[1] y
     /* 6971 */   // No operand predicates
     /* 6971 */   // MIs[0] idx
     /* 6971 */   // No operand predicates
     /* 6971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6973 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 6973 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6976 */ // Label 454: @6976
     /* 6976 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(7008), // Rule ID 29 //
     /* 6981 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 6984 */   // MIs[0] root
     /* 6984 */   // No operand predicates
     /* 6984 */   // MIs[0] src
     /* 6984 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6988 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 6992 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 6995 */   // MIs[1] unused
     /* 6995 */   // No operand predicates
     /* 6995 */   // MIs[0] idx
     /* 6995 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6999 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7003 */   // MIs[2] imm
     /* 7003 */   // No operand predicates
     /* 7003 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7005 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 7005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 7008 */ // Label 455: @7008
     /* 7008 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(7032), // Rule ID 21 //
     /* 7013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 7016 */   // MIs[0] root
     /* 7016 */   // No operand predicates
     /* 7016 */   // MIs[0] vector
     /* 7016 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7024 */   // MIs[0] idx
     /* 7024 */   // No operand predicates
     /* 7024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7026 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 7026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7029 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7031 */   GIR_EraseRootFromParent_Done,
     /* 7032 */ // Label 456: @7032
     /* 7032 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7056), // Rule ID 22 //
     /* 7037 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 7040 */   // MIs[0] root
     /* 7040 */   // No operand predicates
     /* 7040 */   // MIs[0] vector
     /* 7040 */   // No operand predicates
     /* 7040 */   // MIs[0] idx
     /* 7040 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7050 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 7050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7053 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7055 */   GIR_EraseRootFromParent_Done,
     /* 7056 */ // Label 457: @7056
     /* 7056 */ GIM_Reject,
     /* 7057 */ // Label 94: @7057
     /* 7057 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7068), // Rule ID 96 //
     /* 7062 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 7065 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7065 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 7068 */ // Label 458: @7068
     /* 7068 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7079), // Rule ID 98 //
     /* 7073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 7076 */   // Combiner Rule #79: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 7079 */ // Label 459: @7079
     /* 7079 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(7090), // Rule ID 342 //
     /* 7084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 7087 */   // Combiner Rule #197: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 7090 */ // Label 460: @7090
     /* 7090 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(7101), // Rule ID 344 //
     /* 7095 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 7098 */   // Combiner Rule #199: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7098 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 7101 */ // Label 461: @7101
     /* 7101 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(7112), // Rule ID 362 //
     /* 7106 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 7109 */   // Combiner Rule #215: shuffle_to_extract; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7109 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 7112 */ // Label 462: @7112
     /* 7112 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(7133), // Rule ID 343 //
     /* 7117 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 7120 */   // MIs[0] root
     /* 7120 */   // No operand predicates
     /* 7120 */   // MIs[0] src1
     /* 7120 */   // No operand predicates
     /* 7120 */   // MIs[0] undef
     /* 7120 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7128 */   // MIs[0] mask
     /* 7128 */   // No operand predicates
     /* 7128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7130 */   // Combiner Rule #198: combine_shuffle_undef_rhs
     /* 7130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 7133 */ // Label 463: @7133
     /* 7133 */ GIM_Reject,
     /* 7134 */ // Label 95: @7134
     /* 7134 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(7178), // Rule ID 221 //
     /* 7139 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 7142 */   // MIs[0] d
     /* 7142 */   // No operand predicates
     /* 7142 */   // MIs[0] src
     /* 7142 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7150 */   // MIs[1] rev
     /* 7150 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7154 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7158 */   // MIs[2] val
     /* 7158 */   // No operand predicates
     /* 7158 */   // MIs[1] amt
     /* 7158 */   // No operand predicates
     /* 7158 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7162 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7164 */   // Combiner Rule #158: bitreverse_lshr
     /* 7164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7167 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7169 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7173 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7177 */   GIR_EraseRootFromParent_Done,
     /* 7178 */ // Label 464: @7178
     /* 7178 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(7222), // Rule ID 220 //
     /* 7183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 7186 */   // MIs[0] d
     /* 7186 */   // No operand predicates
     /* 7186 */   // MIs[0] src
     /* 7186 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7194 */   // MIs[1] rev
     /* 7194 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7198 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7202 */   // MIs[2] val
     /* 7202 */   // No operand predicates
     /* 7202 */   // MIs[1] amt
     /* 7202 */   // No operand predicates
     /* 7202 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 7206 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7208 */   // Combiner Rule #157: bitreverse_shl
     /* 7208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7211 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7213 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7217 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7221 */   GIR_EraseRootFromParent_Done,
     /* 7222 */ // Label 465: @7222
     /* 7222 */ GIM_Reject,
     /* 7223 */ // Label 96: @7223
     /* 7223 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(7244), // Rule ID 176 //
     /* 7228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 7231 */   // MIs[0] dst
     /* 7231 */   // No operand predicates
     /* 7231 */   // MIs[0] src0
     /* 7231 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7239 */   // MIs[1] cst
     /* 7239 */   // No operand predicates
     /* 7239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7241 */   // Combiner Rule #134: constant_fold_fsqrt
     /* 7241 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 7244 */ // Label 466: @7244
     /* 7244 */ GIM_Reject,
     /* 7245 */ // Label 97: @7245
     /* 7245 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(7259), // Rule ID 363 //
     /* 7250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 7253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 7256 */   // Combiner Rule #216: ext_addv_to_udot_addv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7256 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 7259 */ // Label 467: @7259
     /* 7259 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(7270), // Rule ID 364 //
     /* 7264 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 7267 */   // Combiner Rule #217: ext_uaddv_to_uaddlv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7267 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 7270 */ // Label 468: @7270
     /* 7270 */ GIM_Reject,
     /* 7271 */ // Label 98: @7271
     /* 7271 */ GIM_Reject,
     /* 7272 */ }; // Size: 7272 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

